<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Kurt Gusbeth <info@myquizandpoll.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */


$LANG->includeLLFile('EXT:myquizpoll/mod1/locallang.xml');
require_once(PATH_t3lib . 'class.t3lib_scbase.php');
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]



/**
 * Module 'My quiz and poll' for the 'myquizpoll' extension.
 *
 * @author	Kurt Gusbeth <info@myquizandpoll.de>
 * @package	TYPO3
 * @subpackage	tx_myquizpoll
 */
class  tx_myquizpoll_module1 extends t3lib_SCbase {
	var $pageinfo;
	var $path;

	/**
	 * Initializes the Module
	 * @return	void
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		parent::init();

		/*
		if (t3lib_div::_GP('clear_all_cache'))	{
			$this->include_once[] = PATH_t3lib.'class.t3lib_tcemain.php';
		}
		*/
		$this->path = t3lib_extMgm::extRelPath("myquizpoll").'mod1/';
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 *
	 * @return	void
	 */
	function menuConfig()	{
		global $LANG;
		if (t3lib_div::_GP('user_id')) {
			$fArray = Array();
//				'1' => $LANG->getLL('function1a'),
//				'2' => $LANG->getLL('function2a')
//			);
		} else {
			$fArray = Array (
				'1' => $LANG->getLL('function1'),
				'2' => $LANG->getLL('function2'),
				'3' => $LANG->getLL('function3'),
				'4' => $LANG->getLL('function4'),
				'8' => $LANG->getLL('function8'),
				'9' => $LANG->getLL('function9')
			);
		}
		$this->MOD_MENU = Array (
			'function' => $fArray 
		);
		parent::menuConfig();
	}
	
	/**
	 * Inserts a line to the database
	 *
	 * @return	string
	 */
	function insertLine($names, $values, $Felder) {
		$result = '';
		$convert = intval(t3lib_div::_GP('convert'));
		$show_it = intval(t3lib_div::_GP('show_it'));
		for ($i=0; $i<count($names); $i++) {
			$feld = $names[$i];
			if ($feld=='correct') {	// Ausnahmefall
				$feld = 'correct'.$Felder[$i];
				$values[$feld] = 1;
			} else {
				if ($convert)
					$values[$feld] = iconv('iso-8859-1','utf-8',$Felder[$i]);
				else
					$values[$feld] = $Felder[$i];
			}
			if ($show_it)
				$result .= $feld .' => "'.$values[$feld].'", ';
		}
		if ($show_it) {
			$feld='sorting';
			$result .= $feld .' => "'.$values[$feld].'", ';
			$feld='pid';
			$result .= $feld .' => "'.$values[$feld].'", ';
			$feld='sys_language_uid';
			$result .= $feld .' => "'.$values[$feld].'", ';
			$feld='cruser_id';
			$result .= $feld .' => "'.$values[$feld].'", ';
		}
		if ($show_it<2) {
			$GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_myquizpoll_question',$values);
			$insert_id = $GLOBALS['TYPO3_DB']->sql_insert_id();
			$result .= 'uid => '.$insert_id;
		}
		return $result;
	}
	

	/**
	 * Main function of the module. Write the content to $this->content
	 * If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	 *
	 * @return	[type]		...
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;
		
		if (($this->id && $access) || ($BE_USER->user['admin'] && !$this->id))	{

				// Draw the header.
			//$link = htmlspecialchars(t3lib_div::linkThisScript());
			$link = $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'];
			$this->doc = t3lib_div::makeInstance('mediumDoc');
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form='<form action="'.$link.'" method="post" enctype="multipart/form-data" name="myquiz">';
//			$this->doc->form.='<input type="hidden" name="M" value="tools_txextensionlistM1" />'."\n";
//			$this->doc->form.='<input type="hidden" name="id" value="'.t3lib_div::_GP('id').'" />'."\n";
			$this->doc->form.='<input type="hidden" name="delall" value="0" />'."\n";
			
			// Styles
			//$this->doc->styleSheetFile2=$GLOBALS["temp_modPath"].'style.css' ODER "../".substr(t3lib_extMgm::extPath($this->extName),strlen(PATH_site))."mod1/style.css";
			if (file_exists(t3lib_div::getIndpEnv('TYPO3_DOCUMENT_ROOT').'/uploads/tx_myquizpoll/style.css'))
				$filename = '/uploads/tx_myquizpoll/style.css';
			else
				$filename = $this->path.'style.css';
			$this->doc->styleSheetFile2 = $filename;
			
				// JavaScript
			$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
			';
			$this->doc->postCode='
				<script language="javascript" type="text/javascript">
					script_ended = 1;
					if (top.fsMod) top.fsMod.recentIds["web"] = 0;
				</script>
			';

			$headerSection = $this->doc->getHeader('pages',$this->pageinfo,$this->pageinfo['_thePath']).'<br />'.$LANG->sL('LLL:EXT:lang/locallang_core.xml:labels.path').': '.t3lib_div::fixed_lgd_pre($this->pageinfo['_thePath'],50);

			$this->content.=$this->doc->startPage($LANG->getLL('title'));
			$this->content.=$this->doc->header($LANG->getLL('title'));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->section('',$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,'SET[function]',$this->MOD_SETTINGS['function'],$this->MOD_MENU['function'])));
			$this->content.=$this->doc->divider(5);


			// Render content:
			$this->moduleContent();


			// ShortCut
			if ($BE_USER->mayMakeShortcut())	{
				$this->content.=$this->doc->spacer(20).$this->doc->section('',$this->doc->makeShortcutIcon('id',implode(',',array_keys($this->MOD_MENU)),$this->MCONF['name']));
			}

			$this->content.=$this->doc->spacer(10);
		} else {
				// If no access or if ID == zero

			$this->doc = t3lib_div::makeInstance('mediumDoc');
			$this->doc->backPath = $BACK_PATH;

			$this->content.=$this->doc->startPage($LANG->getLL('title'));
			$this->content.=$this->doc->header($LANG->getLL('title'));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}
	
	}

	/**
	 * Prints out the module HTML
	 *
	 * @return	void
	 */
	function printContent()	{
		$this->content.=$this->doc->endPage();
		echo $this->content;
	}

	/**
	 * Generates the module content
	 *
	 * @return	void
	 */
	function moduleContent()	{
		global $LANG,$BE_USER;
		$id = intval(t3lib_div::_GP('id'));
		$lid = intval(t3lib_div::_GP('lid'));
		$ep = intval(t3lib_div::_GP('ep'));
		if (!$ep) $ep=8;
		$pointer = intval(t3lib_div::_GP('pointer'));
		$path = t3lib_extMgm::extRelPath("myquizpoll").'mod1/';
		$filename_new = t3lib_div::getIndpEnv('TYPO3_DOCUMENT_ROOT').'/uploads/tx_myquizpoll/style.css';	// statt $_SERVER["DOCUMENT_ROOT"]
		$filename_old = $path.'style.css';
		$head = '';
		$content = '';
		$questions='';
		$mode = $this->MOD_SETTINGS['function'];
		
		if (t3lib_div::_GP('delall')==1) {	// delete all rows
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('1',
				'tx_myquizpoll_result',
				'PID='.$id.' AND sys_language_uid='.$lid,
				'',
				'',
				'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
			$query = $GLOBALS['TYPO3_DB']->DELETEquery('tx_myquizpoll_relation', "PID=$id AND sys_language_uid=$lid");
			$GLOBALS['TYPO3_DB']->sql(TYPO3_db, $query);
			$query = $GLOBALS['TYPO3_DB']->DELETEquery('tx_myquizpoll_result', "PID=$id AND sys_language_uid=$lid");
			$GLOBALS['TYPO3_DB']->sql(TYPO3_db, $query);
			$content .= '<p><strong>'.$LANG->getLL('action').": $rows ".$LANG->getLL('deleted').'</strong></p><br /><br />';		
		} else if (t3lib_div::_GP('del_some') && is_array(t3lib_div::_GP('delit'))) {	// deleting rows... 
			$delArray = t3lib_div::_GP('delit');
			$delString = implode(",", $delArray);
			$query = $GLOBALS['TYPO3_DB']->DELETEquery('tx_myquizpoll_relation', "PID=$id AND user_id IN ($delString)");
			$GLOBALS['TYPO3_DB']->sql(TYPO3_db, $query);
			$query = $GLOBALS['TYPO3_DB']->DELETEquery('tx_myquizpoll_result', "PID=$id AND uid IN ($delString)");
			$GLOBALS['TYPO3_DB']->sql(TYPO3_db, $query);
			$content .= '<p><strong>'.$LANG->getLL('action').': '.count($delArray).' '.$LANG->getLL('deleted').'</strong></p><br /><br />';
		} else if (t3lib_div::_GP('user_id')) {
			$uid = intval(t3lib_div::_GP('user_id'));
			$detail = intval(t3lib_div::_GP('detail'));
			$userHash = array();
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
				'tx_myquizpoll_relation',
				'user_id='.$uid.' AND pid='.$id.' AND sys_language_uid='.$lid,
				'',
				'',
				'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){
					$qno = $row['question_id'];
					for ($i=1; $i<10; $i++) {
						$userHash[$qno]['c'.$i] = $row['checked'.$i];
					}
					$userHash[$qno]['textinput'] = $row['textinput'];
					$userHash[$qno]['points'] = $row['points'];
					$questions.=",$qno";
				}
				$questions=substr($questions,1);
				
				// Get all questions and answers from the database
				$questionsArray = array();
				$questionNumber = 0;
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
						'tx_myquizpoll_question',
						'uid IN ('.$questions.')',	//pid='.$id.' AND sys_language_uid='.$lid,
						'',
						'sorting',
						'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if ($rows>0) {
					$this->content.='<div class="quizpoll_stat_total">';
					$lastQuestion=0;
					if (!$detail) {
						$this->content.='<div class="quizpoll_stat2_question_h">'.$LANG->getLL('question').'</div>';
						$this->content.='<div class="quizpoll_stat2_answer_h">'.$LANG->getLL('answer').'</div>';
						$this->content.='<div class="quizpoll_stat2_correct_h">'.$LANG->getLL('correct_answer').'</div>';
					}
					
					while($rowA = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){
						$questionUID = $rowA['uid'];						
						if (!is_array($userHash[$questionUID]))
							continue;				// vorher nicht angezeigte Fragen auch jetzt nicht anzeigen! 
						
						$questionNumber++;
						$this->content.='<div class="quizpoll_stat_around">';
						if ($detail) {
							$this->content.=$questionNumber.'.) '.$rowA['title'].': '.$userHash[$questionUID]['points'].' '.$LANG->getLL('points').'<br />';
							$this->content.='<div class="quizpoll_stat_question">'.$rowA['name'].'</div>';
							for( $answerNumber=1; $answerNumber <= 10; $answerNumber++ ) {
								if ($userHash[$questionUID]['c'.$answerNumber]) {	// was a answer checked by the user?									
									if ($rowA['qtype']!=3 && $rowA['qtype']!=5) {
										$this->content.='&nbsp; '.$rowA['answer'.$answerNumber]."<br />\n";
									} else {							
										$this->content.='&nbsp; '.$userHash[$questionUID]['textinput'];
									}
								}
								if ($rowA['qtype']==5) break;
							}
						} else {
							for( $answerNumber=1; $answerNumber <= 10; $answerNumber++ ) {								
								if ($userHash[$questionUID]['c'.$answerNumber]) {
									if ($lastQuestion!=$questionNumber && $lastQuestion>0)
										$this->content.='<hr style="clear:both;width:415px;" />'."\n";
									$this->content.='<div class="quizpoll_stat2_question">'.$questionNumber.'</div>';
									$this->content.='<div class="quizpoll_stat2_answer">'.$answerNumber.'</div>';
									$this->content.='<div class="quizpoll_stat2_correct">';
									if (($rowA['qtype']!=3 || $answerNumber==1) && $rowA['qtype']!=5) {
										if ($rowA['correct'.$answerNumber]) {											
											$this->content.='<span class="quizpoll_yes">'.$LANG->getLL('yes').'</span>';
										} else {
											$this->content.='<span class="quizpoll_no">'.$LANG->getLL('no').'</span>';
										}
									} else {							
										$this->content.=$userHash[$questionUID]['textinput'];
									}
									$this->content.='</div>';
									$lastQuestion=$questionNumber;
								}
								if ($rowA['qtype']==5) break;
							}
						}
						$this->content.="</div>\n";
					}
					$this->content.="</div>\n";
				}				
			} else {
				$this->content.='<div align="center"><strong>0 '.$LANG->getLL('quiz_results')."</strong></div><br />\n";
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res5);
			return;
		} else if (t3lib_div::_GP('mystyles')) {
			$datei = fopen($filename_new,"w+");
			fputs($datei, t3lib_div::_GP('mystyles'));
			fclose ($datei);
		} else if (t3lib_div::_GP('daten_id') && $_FILES['uploadfile'] && trim($_FILES['uploadfile']['name'])) {
			$daten_id = intval(t3lib_div::_GP('daten_id'));
			$lang_id = intval(t3lib_div::_GP('lang_id'));
			$show_it = intval(t3lib_div::_GP('show_it'));
			$feldtrenner = t3lib_div::_GP('feldtrenner');
			$texttrenner = t3lib_div::_GP('texttrenner');
			//$content .= '<p><strong>'.$LANG->getLL('action').': importiere...</strong></p><br /><br />';
			//$file = $GLOBALS["HTTP_POST_FILES"]["uploadfile"];
			//$file = $_FILES["uploadfile"];
			$filename = $_FILES["uploadfile"]["tmp_name"];
			if (file_exists($filename)) {				
			//	$filename =  $GLOBALS["HTTP_SERVER_VARS"]["DOCUMENT_ROOT"]."/uploads/tx_myquizpoll/".$file["name"];
				$target_path = t3lib_div::getIndpEnv('TYPO3_DOCUMENT_ROOT') .'/uploads/tx_myquizpoll/import.csv';	//. basename( $file['name']);
				if(!move_uploaded_file($filename, $target_path)){
					$content.='<div><strong>Error:</strong> '."Upload verreckt! $filename -&gt; $target_path</div><br />";
				}
				$lines = file($target_path);
				if ( count($lines) > 1 ) {
					$nr=0;
					$sorting=0;
					$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('max(sorting)',
						'tx_myquizpoll_question',
						'PID='.$daten_id.' AND sys_language_uid='.$lang_id,
						'',
						'',
						'');
					$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
					if ($rows>0) {							// DB entries found?
						while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
							$sorting = intval($row['max(sorting)']);
						}
					}
					$fields_values = array();
					$fields_values['pid'] = $daten_id;
					$fields_values['sys_language_uid'] = $lang_id;
					$fields_values['tstamp'] = time();
					$fields_values['crdate'] = time();
					$fields_values['cruser_id'] = $BE_USER->user["uid"];
					$handle = fopen ($target_path, "r");              // Datei zum Lesen oeffnen
					if ($texttrenner) {
						while ( ($Felder = fgetcsv ($handle, 1000, $feldtrenner, $texttrenner)) !== FALSE ) {
							$nr++;
							if ($nr==1) {
								$fields_names = $Felder;
							} else {
								$sorting++;
								$fields_values['sorting'] = $sorting;
								$output.=$this->insertLine($fields_names, $fields_values, $Felder)."<br />\n";
							}
						}
					} else {
						while ( ($Felder = fgetcsv ($handle, 1000, $feldtrenner)) !== FALSE ) {
							$nr++;
							if ($nr==1) {
								$fields_names = $Felder;
							} else {
								$sorting++;
								$fields_values['sorting'] = $sorting;
								$output.=$this->insertLine($fields_names, $fields_values, $Felder)."<br />\n";
							}
						}
					}
					fclose ($handle);
					if ($show_it)
						$content .= '<div>'.$output."</div><br />\n";
					if ($show_it<2)
						$content .= '<div><strong>'.$LANG->getLL('action').'</strong>: '.($nr-1).' '.$LANG->getLL('imp_imported')."</div><br />\n";
				} else {
					$content .= '<div><strong>Error:</strong> no lines found!</div><br />';
				}
			}
		}
		
		// begin output
		$link = htmlspecialchars(t3lib_div::linkThisScript()); // . "?M=tools_txextensionlistM1&id=$id";
		if (t3lib_div::_GP('sortBy')) {
			$sortBy = t3lib_div::_GP('sortBy');
		} else {
			$sortBy = 'crdate DESC';
		}
		if ($pointer>0) {
			$limitTo = ($pointer*$ep).','.$ep;
		} else {
			$limitTo = $ep;
		}
		
		if ($mode<3) {
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('count(1)',
								'tx_myquizpoll_result',
								'PID='.$id.' AND sys_language_uid='.$lid,
								'',
								'',
								'');
			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
			$rowsTotal=$row['count(1)'];
		}
		switch($mode)	{
			case 1:			
				$head=$LANG->getLL('function1');
				$catArray = array();
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,name',
								'tx_myquizpoll_category',
								'',	//'PID='.$id,
								'',
								'',
								'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
						$uid = $row['uid'];
						$catArray[$uid] = $row['name'];
					}
				}
				
				$userAray = array();
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('DISTINCT user_id',
					'tx_myquizpoll_relation',
					'PID='.$id.' AND sys_language_uid='.$lid,
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
				if ($rows>0) {							// DB entries found?
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
						$user_id = $row['user_id'];
						$userAray[$user_id] = 1;
					}
				}
				
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
								'tx_myquizpoll_result',
								'PID='.$id.' AND sys_language_uid='.$lid,
								'',
								$sortBy,
								$limitTo);
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
				if ($rows>0) {							// DB entries found?
					$nr = 0;
					$content .= '<div align="center"><strong>'.$rowsTotal.' '.$LANG->getLL('quiz_results').":</strong></div><br />\n";
					$content .= '<table style="border:1px #333 solid;"><tr style="background-color:#fff;"><th>'.$LANG->getLL('number').'</th><th>-</th><th><a href="';
//					$sorting = ($sortBy == 'sys_language_uid DESC') ? 'sys_language_uid ASC' : 'sys_language_uid DESC';
//					$content .= $link.'&sortBy='.urlencode($sorting).'">'.$LANG->getLL('lang').'</a></th><th><a href="';
					$sorting = ($sortBy == 'crdate DESC') ? 'crdate ASC' : 'crdate DESC';
					$content .= $link.'&sortBy='.urlencode($sorting).'">'.$LANG->getLL('date').'</a></th><th><a href="';
					$sorting = ($sortBy == 'name ASC') ? 'name DESC' : 'name ASC';
					$content .= $link.'&sortBy='.urlencode($sorting).'">'.$LANG->getLL('user_data').'</a></th><th><a href="';
					$sorting = ($sortBy == 'p_or_a ASC') ? 'p_or_a DESC' : 'p_or_a ASC';
					$content .= $link.'&sortBy='.urlencode($sorting).'">'.$LANG->getLL('points_percent').'</a></th><th>'.$LANG->getLL('opoints_opercent').'</th>';
					$content .= '<th>'.$LANG->getLL('answ_skipped').'</th><th>'.$LANG->getLL('answ_corr_false').'</th>';
					$content .= '<th>'.$LANG->getLL('last_next_cat').'</th></tr>'."\n";
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
						$nr++;
						$uid = $row['uid'];
						$cat1 = $row['lastcat'];
						$cat2 = $row['nextcat'];
						if ($nr%2 == 0)
							$style='even';
						else
							$style='odd';
						$content .= '<tr class="quizpoll_'.$style.'"><td align="center">'.$nr.':<br /><br />';
						$content .= '<input type="checkbox" name="delit[]" value="'.$uid.'" /></td>';
						$content .= '<td><a href="alt_doc.php?returnUrl=db_list.php%3Fid%3D43%'.$id.'table%3D&edit[tx_myquizpoll_result]['.$uid.']=edit"><img src="'.$path.'icon-edit.jpg" alt="'.$LANG->getLL('function0a').'" title="'.$LANG->getLL('function0a').'" /></a> ';
						if ($userAray[$uid]) {
							$content .= '<a href="javascript:nix();" onclick="popup(\''.$link.'&amp;user_id='.$uid.'&amp;lid='.$lid.'\');"><img src="'.$path.'icon-show1.jpg" alt="'.$LANG->getLL('function1a').'" title="'.$LANG->getLL('function1a').'" /></a> ';
							$content .= '<a href="javascript:nix();" onclick="popup(\''.$link.'&amp;user_id='.$uid.'&amp;lid='.$lid.'&amp;detail=1\');"><img src="'.$path.'icon-show2.jpg" alt="'.$LANG->getLL('function2a').'" title="'.$LANG->getLL('function2a').'" /></a> ';
						}
						$content .= '</td>';
						$content .= '<td>'.date("d.m.Y G:i:s", $row['firsttime']).' - '.date("G:i:s", $row['lasttime']).'</td><td>'.$row['name'];
						if ($row['fe_uid']) $content .= ' (fe_user&nbsp;'.$row['fe_uid'].')<br />';
						$content .= (($row['email']) ? '<br /><span style="font-size:85%;">'.$row['email'].'</span>' : '');
						$content .= (($row['homepage']) ? '<br /><span style="font-size:85%;">'.$row['homepage'].'</span>' : '').'</td>';
						$content .= '<td align="center">'.$row['p_or_a'].'/'.$row['p_max'].'<br /><div style="font-size:90%;">'.$row['percent'].'/100%</div></td>';
						$content .= '<td align="center">'.$row['p_or_a'].'/'.$row['o_max'].'<br /><div style="font-size:90%;">'.$row['o_percent'].'/100%</div></td>';
						$content .= '<td align="center">'.(($row['qids']) ? (substr_count($row['qids'],',')+1) : '0').'/'.(($row['sids']) ? (substr_count($row['sids'],',')+1) : '0').'</td>';
						$content .= '<td align="center">'.(($row['cids']) ? (substr_count($row['cids'],',')+1) : '0').'/'.(($row['fids']) ? (substr_count($row['fids'],',')+1) : '0').'</td>';
						$content .= '<td>'.(($cat1) ? $catArray[$cat1] : '').' '.(($cat1 && $cat2) ? '/' : '').' '.(($cat2) ? $catArray[$cat2] : '').'</td>';
						$content .= "</tr>\n";
//						$jsc .= "document.forms.myquiz.delit[0].checked='true';\n";
					}
					$content .= "</table><br />\n";
					$content .= '<input type="button" name="select_all" value="'.$LANG->getLL('select_all').'" onclick="markAll();" />'."\n";
					$content .= ' <input type="submit" name="del_some" value="'.$LANG->getLL('delete').'" />'."\n";
					$content .= ' <input type="button" name="del_all" value="'.$LANG->getLL('delete_all').'" onclick="delAllRes();" />';
				} else {
					$content .= '<div align="center"><strong>0 '.$LANG->getLL('quiz_results')."</strong></div><br />\n";
				}
			break;
			case 2:
				$head = $LANG->getLL('function2');
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('DISTINCT qids',
					'tx_myquizpoll_result',
					'PID='.$id.' AND sys_language_uid='.$lid,
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
						$questions.=','.$row['qids'];
					}
					$questions=substr($questions,1);
				}
				
				$questArray = array();
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
					'tx_myquizpoll_question',
					'uid IN ('.$questions.')',	//'PID='.$id.' AND sys_language_uid='.$lid,
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
						$uid = $row['uid'];
						$questArray[$uid] = array();
						$questArray[$uid] = $row;
					}
				}
				
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,sys_language_uid,crdate,p_or_a,qids',
					'tx_myquizpoll_result',
					'PID='.$id.' AND sys_language_uid='.$lid,
					'',
					$sortBy,
					$limitTo);
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
				if ($rows>0) {							// DB entries found?
					$nr = 0;
					$content .= '<div align="center"><strong>'.$rowsTotal.' '.$LANG->getLL('poll_results').":</strong></div><br />\n";
					$content .= '<table style="border:1px #333 solid;"><tr style="background-color:#fff;"><th>'.$LANG->getLL('number').'</th><th><a href="';
//					$sorting = ($sortBy == 'sys_language_uid DESC') ? 'sys_language_uid ASC' : 'sys_language_uid DESC';
//					$content .= $link.'&sortBy='.urlencode($sorting).'">'.$LANG->getLL('lang').'</a></th><th><a href="';
					$sorting = ($sortBy == 'crdate DESC') ? 'crdate ASC' : 'crdate DESC';
					$content .= $link.'&sortBy='.urlencode($sorting).'">'.$LANG->getLL('date').'</a></th><th>';
					$content .= $LANG->getLL('question').'</a></th><th>'.$LANG->getLL('answer').'</th></tr>'."\n";
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
						$nr++;
						$uid = $row['uid'];
						if ($nr%2 == 0)
							$style='even';
						else
							$style='odd';
						$content .= '<tr class="quizpoll_'.$style.'"><td align="center">';
						$content .= '<a href="alt_doc.php?returnUrl=db_list.php%3Fid%3D43%'.$id.'table%3D&edit[tx_myquizpoll_result]['.$uid.']=edit"><u>'.$nr.'</u></a>: ';
						$content .= '<input type="checkbox" name="delit[]" value="'.$uid.'" /></td>';
//						$content .= '<td align="center">'.$row['sys_language_uid'].'</td>';
						$content .= '<td>'.date("d.m.Y G:i:s", $row['crdate']).'</td>';
						$question = intval($row['qids']);
						$content .= '<td>'.$questArray[$question]['title'].'</td>';
						$answer = intval($row['p_or_a']);
						$content .= '<td>'.$questArray[$question]['answer'.$answer]."</td></tr>\n";
					}
					$content .= "</table><br />\n";
					$content .= '<input type="button" name="select_all" value="'.$LANG->getLL('select_all').'" onclick="markAll();" />'."\n";
					$content .= ' <input type="submit" name="del_some" value="'.$LANG->getLL('delete').'" />'."\n";
					$content .= ' <input type="button" name="del_all" value="'.$LANG->getLL('delete_all').'" onclick="delAllRes();" />';
				} else {
					$content .= '<div align="center"><strong>0 '.$LANG->getLL('poll_results')."</strong></div><br />\n";
				}
			break;
			case 3:
				$head = $LANG->getLL('function3');
				$content .= '<div align="center"><strong>'.$LANG->getLL('evaluation')."</strong></div><br />\n";
				
				$ansArray = array();
				$votesTotal = 0;
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
					'tx_myquizpoll_relation',
					'PID='.$id.' AND sys_language_uid='.$lid,
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
				if ($rows>0) {							// DB entries found?
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
						$qid = intval($row['question_id']);
						if (!is_array($ansArray[$qid])) $ansArray[$qid] = array();
						for ($i=1; $i<=10; $i++) {
							if ($row['checked'.$i]) {
								$ansArray[$qid][$i]++;
								$ansArray[$qid]['votes']++;
								$votesTotal++;
							}
						}
						$questions.=",$qid";
					}
					$questions=substr($questions,1);
				}
			break;
			case 4:
				$head = $LANG->getLL('function4');
				$content .= '<div align="center"><strong>'.$LANG->getLL('evaluation')."</strong></div><br />\n";
				
				$ansArray = array();
				$votesTotal = 0;
				$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('p_or_a,qids',
					'tx_myquizpoll_result',
					'PID='.$id.' AND sys_language_uid='.$lid,
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
				if ($rows>0) {							// DB entries found?
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
						$qid = intval($row['qids']);
						$aid = intval($row['p_or_a']);
						if (!is_array($ansArray[$qid])) $ansArray[$qid] = array();
						$ansArray[$qid][$aid]++;
						$ansArray[$qid]['votes']++;
						$votesTotal++;
						$questions.=",$qid";
					}
					$questions=substr($questions,1);
				}
			break;
			case 8:
				$head = $LANG->getLL('function8');
				$content .= '<div align="center"><strong>CSV-Import</strong></div><br />'."\n";
				$content .= '<p>'.$LANG->getLL('imp_delimiter').': <input name="feldtrenner" type="text" value=";" size="5" /> &nbsp; ';
				$content .= $LANG->getLL('imp_enclosure').': <input name="texttrenner" type="text" value="" size="5" /></p><br />';
				$content .= '<p>'.$LANG->getLL('imp_sys_id').' (Sysfolder): <input name="daten_id" type="text" size="5" value="'.$id.'" /></p><br />';
				$content .= '<p>'.$LANG->getLL('imp_lang_id').': <input name="lang_id" type="text" size="5" value="" /></p><br />';
				$content .= '<p>'.$LANG->getLL('imp_convert').' <input name="convert" type="checkbox" value="1" /></p><br />';
				$content .= '<p>'.$LANG->getLL('imp_show_it').' <input name="show_it" type="radio" value="0" checked="checked" /> '.$LANG->getLL('no');
				$content .= ' &nbsp; <input name="show_it" type="radio" value="1" /> '.$LANG->getLL('yes');
				$content .= ' &nbsp; <input name="show_it" type="radio" value="2" /> '.$LANG->getLL('imp_test_mode')."</p><br />\n";
				$content .= '<p>'.$LANG->getLL('imp_csv_example').':</p><pre>'."\n";
				$content .= 'title;name;qtype;answer1;correct1;answer2;correct2;answer3;correct3;answer4;correct4;answer5;correct5;explanation;points;image;alt_text'."\n";
				$content .= 'Natur;Nationalparks in Kroatien?;0;Biokovo;1;Bihor;0;Plitvice;1;Tatra;0;Krka;1;Muss man wissen...;3;example.jpg;Nationalpark';
				$content .= "\n</pre><br /><p>".$LANG->getLL('imp_csv_example2').":</p><pre>\n";
				$content .= '"title","name","qtype","answer1","answer2","answer3","answer4","correct","explanation","points"'."\n";
				$content .= '"Natur","Nationalpark in Polen?","1","Biokovo","Bihor","Plitvice","Tatra","4","Muss man nicht wissen...","10"'."\n";
				$content .= "\n</pre><br />\n";
				$content .= '<input type="file" name="uploadfile" size="40" /><br /><br />';
				$content .= '<input type="submit" name="import" value="Import" />';
			break;
			case 9:
				$head = $LANG->getLL('function9');
				$content .= '<div align="center"><strong>'.$LANG->getLL('mystyles')."</strong></div><br />\n";
				
				if (file_exists($filename_new))
					$filename = $filename_new;
				else
					$filename = $filename_old;
				if (file_exists($filename)) {
					$datei = fopen($filename,"r");
					$content .= '<textarea name="mystyles" rows="15" cols="50">';
					while (!feof($datei)) {
						$content .= fgets($datei);
					}
					$content .= "</textarea><br /><br />\n";
					fclose ($datei);
				}
				$content .= '<input type="submit" name="save" value="'.$LANG->getLL('save_styles').'" />';
			break;
		}
		
		if (($mode==3 || $mode==4) && $questions) {
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
				'tx_myquizpoll_question',
				'uid IN ('.$questions.')',	//'PID='.$id.' AND sys_language_uid='.$lid.' AND deleted=0',
				'',
				'sys_language_uid, sorting',
				'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
					$uid = intval($row['uid']);
					$votes = $ansArray[$uid]['votes'];
					$content .= '<p><strong>'.$row['title']."</strong><br />";
					for ($i=1; $i<=10; $i++) {
						if ($ansArray[$uid][$i]) {
							$percent2=round(100*$ansArray[$uid][$i]/$votes, 2);
							$percent0=round($percent2);
							if ($percent0>0) {
								$content .= '<img src="'.$path.'percent-l.jpg" alt="'.$percent2.'%" title="'.$percent2.'%" width="'.$percent0.'" height="10" />';
								$percent0 = 100 - $percent0;
								$content .= '<img src="'.$path.'percent-r.jpg" alt="'.$percent2.'%" title="'.$percent2.'%" width="'.$percent0.'" height="10" />';
							} else {
								$content .= '<img src="'.$this->path.'percent-r.jpg" alt="0%" title="0%" width="100" height="10" />';
							}
							$content .= ' <span class="quizpoll_stat_count">'.$ansArray[$uid][$i]." ($percent2%) </span>&nbsp;";
							$content .= $row['answer'.$i]."<br />\n";
						} else if ($row['answer'.$i]) {
							$content .= '<img src="'.$this->path.'percent-r.jpg" alt="0%" title="0%" width="100" height="10" />';
							$content .= ' <span class="quizpoll_stat_count">0 </span>&nbsp;'.$row['answer'.$i]."<br />\n";
						}
					}
					$content .= "</p>\n";
				}
				$content .= '<br /><p>'.$LANG->getLL('votesTotal').": $votesTotal</p><br />\n";
			}
		} else if ($mode<3) {	
			if ($rowsTotal>$ep) {
				$fin = ceil($rowsTotal/$ep)-1;
				$content .= '<hr />'.$LANG->getLL('page').': ';
				if ($pointer>0) {
					$content .= '<a href="'.$link.'&pointer=0&ep='.$ep.'&lid='.$lid.'">'.$LANG->getLL('begin').'</a> . ';
					$content .= '<a href="'.$link.'&pointer='.($pointer-1).'&ep='.$ep.'&lid='.$lid.'">'.$pointer.'</a> . ';
				}
				$content .= '<b>'.($pointer+1).'</b> ';
				if ($pointer<$fin) {
					$content .= '. <a href="'.$link.'&pointer='.($pointer+1).'&ep='.$ep.'&lid='.$lid.'">'.($pointer+2).'</a> ';
					$content .= '. <a href="'.$link.'&pointer='.$fin.'&ep='.$ep.'&lid='.$lid.'">'.$LANG->getLL('end').'</a>';
				}
			}
			$content .= "<hr />\n".$LANG->getLL('entriesPage').': <input type="text" name="ep" value="'.$ep.'" size="4" /> ';
		}
		
		if ($mode<7) {
			$content .= "<br />\n".$LANG->getLL('language').': <select name="lid"><option value="0">'.$LANG->getLL('default')."</option>\n";
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('DISTINCT sys_language_uid, sys_language.title',
				'tx_myquizpoll_result, sys_language',
				'tx_myquizpoll_result.PID='.$id.' AND sys_language_uid>0 AND sys_language_uid=sys_language.uid',
				'',
				'sys_language_uid',
				'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res);
			if ($rows>0) {							// DB entries found?
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)){
					$content .= '<option value="'.$row['sys_language_uid'].'"';
					if ($lid==$row['sys_language_uid']) $content .= ' selected';
					$content .= '>'.$row['title']."</option>\n";
				}
			}
			$content .= "</select>\n";
			$content .= "<br /><br />\n".'<input type="submit" name="refresh" value="'.$LANG->getLL('refresh').'" />';
			$content .= '<script type="text/javascript">
function delAllRes() {
  Check = confirm("'.$LANG->getLL('sure').'");
  if (Check == true) {
    document.forms.myquiz.delall.value=1;
    document.forms.myquiz.submit();
  } else {
    return;
  }
}
function markAll() {
  for(var i=0; i < document.myquiz.elements["delit[]"].length; i++){
    document.forms.myquiz.elements["delit[]"][i].checked="true";
  }
  return;
}
function popup (url) {
 fenster = window.open(url, "Popupfenster", "width=492,height=500,resizable=yes");
 fenster.focus();
 return false;
}
function nix() {
  return;
}
</script>
';
		}
		
		$this->content.=$this->doc->section($head.':',$content,0,1);
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/mod1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/mod1/index.php']);
}



// Make instance:
$SOBE = t3lib_div::makeInstance('tx_myquizpoll_module1');
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>