<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Kurt Gusbeth <gusbeth@aol.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

class tx_myquizpoll_helper {

	var $maximumPoints;		// Total maximum points of all questions of a quiz
	var $numberQuestions;	// Number of all questions
	var $firsttime;			// Start time of the quiz
	var $pid;
	var $answerChoiceMax;
	var $tableQuestions;
	var $tableAnswers;
	var $tableRelation;
	var $setQuestionsBool = false;
	var $settings;
	var $submitJsc;		// javascript
	var $debug;			// debug texte
	var $cObj = null; // for making typo3 links
//	var $typoVersion; // TYPO3 version
		
	/* constructor */
	function tx_myquizpoll_helper($pid, $lang, $answerChoiceMax, $tableQuestions, $tableAnswers, $tableRelation, $settings) { 
		$this->pid 	= $pid;
		$this->lang = $lang;
		$this->answerChoiceMax	= $answerChoiceMax;
		$this->tableQuestions 	= $tableQuestions;
		$this->tableAnswers		= $tableAnswers;
		$this->tableRelation 	= $tableRelation;
		$this->settings 		= $settings;
		$this->submitJsc		= '';
		$this->debug			= '';
		$this->cObj 			= new tslib_cObj();
//		$this->typoVersion = t3lib_div::int_from_ver($GLOBALS['TYPO_VERSION']);		
	}
	
	
  /**
    * Sets/gets debug text
    */
	function addDebug($text) {
		if ($this->settings['debug'])
			$this->debug .= time().": $text\n";
		return;
	}
	function getDebug() {
		if ($this->settings['debug'])
			return "\n<!--\nDebug output:\n".$this->debug."-->\n";
		else
			return;
	}	
	
  /**
    * Sets/gets JavaScript
    */
	function addEnforceJsc($no,$answers,$type) {
		switch ($type) {
			case 0:	$this->submitJsc .= "if (!quizcheck0(quizform,$no,$answers)){ quizerror($no); return false; }\n";
					break;
			case 1:	$this->submitJsc .= "if (!quizcheck1(quizform,$no,$answers)){ quizerror($no); return false; }\n";
					break;
			case 3:	$this->submitJsc .= "if (!quizcheck3(quizform,$no)){ quizerror($no); return false; }\n";
					break;
			case 4:	$this->submitJsc .= "if (!quizcheck4(quizform,$no,$answers)){ quizerror($no); return false; }\n";
					break;
		}
	}
	function getSubmitJsc() {
		return $this->submitJsc;
	}	
	
  /**
    * Sets/gets the starttime of a page
    */
	function setPageTime($uid, $time) {
		if ($uid && $this->settings['pageTimeSeconds'] && $this->settings['userSession']) {
			$GLOBALS['TSFE']->fe_user->setKey('ses','pagetime'.$uid, $time);
		}
	}
	function getPageTime($uid) {
		if ($uid && $this->settings['pageTimeSeconds'] && $this->settings['userSession']) {
			return $GLOBALS['TSFE']->fe_user->getKey('ses','pagetime'.$uid);
		} else {
			return 0;
		}
	}	

	/**
    * Sets/Gets the starttime of a quiz
    */
	function setFirstTime($uid, $time) {
		$this->firsttime = $time;		
		if ($this->settings['userSession']) {
			$GLOBALS['TSFE']->fe_user->setKey('ses','firsttime'.$uid, $time);
			$this->addDebug('Storing in Object and Session: firsttime='.$time);
		} else {
			$this->addDebug('Storing in Object: firsttime='.$time);
		}
	}
	function getFirstTime($uid) {
		if ($uid) {
			$time = $this->firsttime;
			if (!$time && $this->settings['userSession']) {
				$time = $GLOBALS['TSFE']->fe_user->getKey('ses','firsttime'.$uid);
				$this->firsttime = $time;
			}
			if (!$time) {
				$res6 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('firsttime',
					$this->tableAnswers,
					'uid='.intval($uid).' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($this->tableAnswers),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res6);
				if ($rows>0) {							// DB entry found for current user?
					$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res6);
					$time = $fetchedRow['firsttime'];
				}
				mysql_free_result($res6);
				$this->firsttime = $time;
				if ($this->settings['userSession']) {
					$GLOBALS['TSFE']->fe_user->setKey('ses','firsttime'.$uid, $time);
				}
			}
		} else {
			$time = 0;
		}
		return intval($time);
	}
	
	
  /**
    * Calculate the total maximum scores of all questions of a quiz and no. of all questions
    */
	function setQuestionsVars() {
		$maxPoints = 0;
		$noQuestions = 0;
		
		// Get all questions from the database
		$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
				$this->tableQuestions,
				'pid='.$this->pid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($this->tableQuestions),
				'',
				'',
				'');
		$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
		if ($rows>0) {
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
				$noQuestions++;
				if (!$this->settings['dontShowPoints']) {
					$points = 0;
					for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
						if ($row['answer'.$answerNumber] || $row['answer'.$answerNumber]==='0') {	// was a answer set in the backend?
							$answPoints = 0;
							if ($this->settings['noNegativePoints']<3)
								$answPoints = intval($row['points'.$answerNumber]);
							if ($answPoints > 0) {
								$row['correct'.$answerNumber] = true;		// ACHTUNG: falls Punkte zu einer Antwort gesetzt sind, dann wird die Antwort als RICHTIG bewertet!
							} else {
								$answPoints = intval($row['points']);
							}
							if ($row['correct'.$answerNumber] || $row['qtype']==3) {
								if (($row['qtype'] == 0 || $row['qtype'] == 4) && $this->settings['noNegativePoints']<3) {
									$points+=$answPoints;
								} else if ($answPoints > $points) {
									$points=$answPoints;	// bei punkten pro antwort ODER wenn nicht addiert werden soll
								}
							}
						}
					}
					$maxPoints+=$points;
				}
			}
		}
		$GLOBALS['TYPO3_DB']->sql_free_result($res5);
		
		// doppelt speichern (falls jemand cookies nicht mag)
		$this->maximumPoints = $maxPoints;
		$this->numberQuestions = $noQuestions;
		if ($this->settings['userSession']) {
			$GLOBALS['TSFE']->fe_user->setKey('ses','maximumPoints', $maxPoints);
			$GLOBALS['TSFE']->fe_user->setKey('ses','numberQuestions', $noQuestions);
			$this->addDebug('Storing in Object and Session: maxPoints='.$maxPoints.', noQuestions='.$noQuestions);
		} else {
			$this->addDebug('Storing in Object: maxPoints='.$maxPoints.', noQuestions='.$noQuestions);
		}
		$this->setQuestionsBool = true;
    }
	
	function getQuestionsMaxPoints() {
		if ($this->settings['userSession'])
			$max = $GLOBALS['TSFE']->fe_user->getKey('ses','maximumPoints');
		else
			$max = 0;
		if (!$max && $this->setQuestionsBool)			// wenn keine cookies erlaubt sind...
			$max = $this->maximumPoints;
		else if (!$max && !$this->setQuestionsBool) {	// wenn setQuestionsVars noch nicht aufgerufen wurde
			$this->setQuestionsVars();
			$max = $this->maximumPoints;
		}
		if (!$max) $max = 0;						// wenn alles umsonst war...
		return $max;
	}
	
	// returns how many questios are there in the DB
	function getQuestionsNo() {
		if ($this->settings['userSession'])
			$no = $GLOBALS['TSFE']->fe_user->getKey('ses','numberQuestions');
		else
			$no = 0;
		if (!$no && $this->setQuestionsBool)			// wenn keine cookies erlaubt sind...
			$no = $this->numberQuestions;
		else if (!$no && !$this->setQuestionsBool) {	// wenn setQuestionsVars noch nicht aufgerufen wurde
			$this->setQuestionsVars();
			$no = $this->numberQuestions;
		}
		if (!$no) $no = 0;							// wenn alles umsonst war...
		return $no;
	}
	
	// returns who many questions have been answered yet
	function getQuestionNo($answered) {
		if ($answered=='-') {
			if ($this->settings['userSession'])
				$no = $GLOBALS['TSFE']->fe_user->getKey('ses','numberQuestion');
			else $no = 0;		// unknown
			if ($no==='') $no = 0;	// unknown
		} else if (!$answered) {
			$no = 0;
			if ($this->settings['userSession'])
				$GLOBALS['TSFE']->fe_user->setKey('ses','numberQuestion', $no);
		} else {		// mind. 1 Frage wurde beantwortet oder uebersprungen!
			$no = substr_count($answered, ',') + 1;
			if ($this->settings['userSession'])
				$GLOBALS['TSFE']->fe_user->setKey('ses','numberQuestion', $no);
		}
		return $no;
	}
	
	// checks an email
	function isvalidemail( $email ) {
		if( preg_match( "/[a-zA-Z0-9-.+]+@[a-zA-Z0-9-]+.[a-zA-Z]+/", $email ) > 0 )
			return true;
		else
			return false;
	}
	
	// send email to...
	function sendEmail($html_content,$text_content,$to_mail,$to_name,$to_subject) {
		require_once(PATH_t3lib.'class.t3lib_htmlmail.php');		
		$this->htmlMail = t3lib_div::makeInstance('t3lib_htmlmail');
		$this->htmlMail->start();
		$this->htmlMail->recipient = $to_mail;
		$this->htmlMail->replyto_email = $this->settings['email.']['from_mail'];
		$this->htmlMail->replyto_name = $this->settings['email.']['from_name'];
		$this->htmlMail->from_email = $this->settings['email.']['from_mail'];
		$this->htmlMail->from_name = $this->settings['email.']['from_name'];
		$this->htmlMail->returnPath = $this->settings['email.']['from_mail'];
		$this->htmlMail->subject = $to_subject;
		$this->htmlMail->addPlain($text_content);
		$this->htmlMail->setHTML($this->htmlMail->encodeMsg($html_content));
		$this->htmlMail->send($to_mail);
		$this->addDebug('Mail sent to '.$to_mail);
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_helper.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_helper.php']);
}

?>
