<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Kurt Gusbeth <info@myquizandpoll.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('myquizpoll').'pi1/class.tx_myquizpoll_helper.php'); // PATH_BE_myquizpoll

/**
 * Plugin 'My quiz and poll' for the 'myquizpoll' extension.
 *
 * @author	Kurt Gusbeth <info@myquizandpoll.de>
 * @package	TYPO3
 * @subpackage	tx_myquizpoll
 */
class tx_myquizpoll_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_myquizpoll_pi1';				// Same as class name
	var $scriptRelPath = 'pi1/class.tx_myquizpoll_pi1.php';	// Path to this script relative to the extension directory
	var $extKey        = 'myquizpoll';						// The extension key.
	var $conf = array();
	var $answerChoiceMax = 5;								// This max cannot be changed without changing the TCA (and DB)!
	var $lang = 0;											// language
	var $templateCode = '';
	var $origTemplateCode = '';
	var $xajax;
	
	/**
	 * Main method of your PlugIn
	 *
	 * @param	string		$content: The content of the PlugIn
	 * @param	array		$conf: The PlugIn Configuration
	 * @return	The content that should be displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin 
		$this->pi_loadLL();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$thePID = 0;				// PID of the sysfolder with questions
		$resPID = 0;				// PID of the sysfolder with results
		$nextPID = 0;				// PID for forms
		$finalPID = 0;				// PID for the final page
		$listPID = 0;				// PID for highscore or poll result
		$startPID = 0;				// PID of the startpage
		$uid = 0;					// quiz taker UID?!
		//$firsttime = 0;			// start time of the quiz
		$elapseTime = 0;			// intval($this->conf['quizTimeMinutes'])*60;			// Verflossene Zeit in Sekunden
		$joker1 = 0;				// Joker used?
		$joker2 = 0;
		$joker3 = 0;
		$startPage = false;			// start page which asks only for user data?
		$questionPage = false;		// question page?
		$answerPage = false;		// answer page?
		$finalPage = false;			// final page reached?
		$noQuestions = false;		// no more questions?
		$sendMail = false;			// email should be send?
		$error = false;				// was there an error?
		
		// global $TSFE;
		$this->lang = $GLOBALS['TSFE']->config['config']['sys_language_uid']; 
		//$this->lang = $_GET['L'];
		//if ($this->lang == '') $this->lang = $_POST['L'];
		if ($this->lang == '') $this->lang = 0;		// falls keine Sprache gesetzt wurde
		
		$this->copyFlex();			// copy Felxform-Variables to this->conf
		
		if ( $this->conf['enableCaptcha'] && t3lib_extMgm::isLoaded('sr_freecap') ) {		// load Captcha: Anti-Spam-Tool ??? only if enabled (16.10.2009)
			require_once(t3lib_extMgm::extPath('sr_freecap').'pi2/class.tx_srfreecap_pi2.php');
			$this->freeCap = t3lib_div::makeInstance('tx_srfreecap_pi2');
		}
		
		if( !($this->cObj->data['pages'] == '') ) {		// PID
			$thePID = $this->cObj->data['pages'];
		} elseif( !($this->conf['sysPID'] == '') )  { 
			$thePID = $this->conf['sysPID']; 
		} else { 
			$thePID = $GLOBALS["TSFE"]->id;
		}
		$resPID = ($this->conf['resultsPID']) ? intval($this->conf['resultsPID']) : $thePID;
		$nextPID  = ($this->conf['nextPID'])  ? intval($this->conf['nextPID'])  : $GLOBALS['TSFE']->id;
		$finalPID = ($this->conf['finalPID']) ? intval($this->conf['finalPID']) : $GLOBALS['TSFE']->id;	// oder $nextPID;
		$listPID  = ($this->conf['listPID'])  ? intval($this->conf['listPID'])  : $GLOBALS['TSFE']->id;	// oder $finalPID;
		$startPID = ($this->conf['startPID']) ? intval($this->conf['startPID']) : $GLOBALS['TSFE']->id;
		
		if ($this->conf['answerChoiceMax'])					// antworten pro fragen
			$this->answerChoiceMax = intval($this->conf['answerChoiceMax']);
		
		mt_srand(hexdec(substr(md5(microtime()), -8)) & 0x7fffffff);  // Seed random number generator
		$this->local_cObj = t3lib_div::makeInstance("tslib_cObj");	// Local cObj
		$quiz_taker_ip_address = t3lib_div::getIndpEnv("REMOTE_ADDR");	// Collect ip address of quiz taker
		
		// Get post parameters: Submited Quiz-data
		$quizData = array();
		if (is_array(t3lib_div::GPvar($this->prefixId))) {
		  $quizData = t3lib_div::slashArray(t3lib_div::GPvar($this->prefixId),"strip");
		  if ($quizData["cmd"]=='') {
		    $quizData["cmd"] = $this->conf['CMD'];
		  } elseif ($quizData["cmd"]=='allanswers') {	// or $quizData["cmd"]=='score' or $quizData["cmd"]=='list'
		    $quizData["cmd"] = '';						// for security reasons we want that users can´t see everything
		  }
		} else {
		  $quizData["cmd"] = $this->conf['CMD'];		// get the CMD from the backend
		}
		
		if ($this->conf['dontShowPoints']) {			// ausschalten, was nicht gebraucht wird
			$this->conf['showHighscore'] = 0;
			$this->conf['dontShowHighscoreLink'] = 1;
		}
		
		// Load template
		$this->initTemplate();
		
		// Marker values
		$statisticsArray=array();
		$markerArray=array();
		$subpartArray=array();
		$wrappedSubpartArray=array();
		$markerArrayP=array();
		$markerArrayP["###REF_HIGHSCORE###"] = '';
		$markerArrayP["###REF_HIGHSCORE_URL###"] = '';
		$markerArrayP["###REF_POLLRESULT_URL###"] = '';		
		$markerArrayP["###REF_QUIZ_ANALYSIS###"] = '';
		$markerArrayP["###REF_NO_MORE###"] = '';
		$markerArrayP["###REF_ERRORS###"] = '';
		$markerArrayP["###REF_RES_ERRORS###"] = '';
		$markerArrayP["###REF_JOKERS###"] = '';
		$markerArrayP["###REF_QUESTIONS###"] = '';
		$markerArrayP["###REF_QRESULT###"] = '';
		$markerArrayP["###REF_INTRODUCTION###"] = '';
		$markerArrayP["###REF_QPOINTS###"] = '';
		$markerArrayP["###REF_SKIPPED###"] = '';
		$markerArrayP["###REF_NEXT###"] = '';
		$markerArrayP["###REF_POLLRESULT###"] = '';
		$markerArrayP["###SUBMIT_JSC###"] = '';
		$markerArrayP["###PREFIX###"] = $this->prefixId;
		$markerArrayP["###FORM_URL###"] = $this->pi_getPageLink($nextPID);
		$markerArray["###PREFIX###"] = $this->prefixId;
		$markerArray["###FORM_URL###"] = $markerArrayP["###FORM_URL###"];
		$markerArrayP["###VAR_NOW###"] = $markerArray["###VAR_NOW###"] = time() + 1;  // kleiner Zeitvorsprung (Seite muss ja geladen werden)
		$markerArrayP["###QUIZ_NAME###"] = $markerArray["###QUIZ_NAME###"] = $this->conf['quizName'];
		$markerArray["###NAME###"] = $this->pi_getLL('name','name');
		$markerArray["###EMAIL###"] = $this->pi_getLL('email','email');
		$markerArray["###HOMEPAGE###"] = $this->pi_getLL('homepage','homepage');
		$markerArray["###GO_ON###"] = $this->pi_getLL('go_on','go_on');
		$markerArray["###SUBMIT###"] = $this->pi_getLL('submit','submit');
		$markerArray["###RESET###"] = $this->pi_getLL('reset','reset');
		$markerArray["###CORRECT_ANSWERS###"] = $this->pi_getLL('correct_answers','correct_answers');
		$markerArray["###EXPLANATION###"] = $this->pi_getLL('listFieldHeader_explanation', 'listFieldHeader_explanation');
		$markerArray["###VAR_TOTAL_POINTS###"] = '';
		$markerArray["###VAR_QUESTIONS_CORRECT###"] = '';
		$markerArray["###VAR_QUESTIONS_FALSE###"] = '';
		$markerArray["###VAR_QUESTIONS_ANSWERED###"] = 0;
		//if ($this->conf['enforceSelection']) {
			$markerArrayP["###QUESTION###"] = $this->pi_getLL('listFieldHeader_name','listFieldHeader_name');
			$markerArrayP["###MISSING_ANSWER###"] = $this->pi_getLL('missing_answer','missing_answer');
		//}
		if ($this->conf['pageTimeSeconds'] || $this->conf['quizTimeMinutes']) {
			$markerArray["###TIME_UP1###"] = $this->pi_getLL('time_up1','time_up1');
			$markerArray["###LIMIT1A###"] = $this->pi_getLL('limit1a','limit1a');
			$markerArray["###LIMIT1B###"] = $this->pi_getLL('limit1b','limit1b');
			$markerArray["###TIME_UP2###"] = $this->pi_getLL('time_up2','time_up2');
			$markerArray["###LIMIT2A###"] = $this->pi_getLL('limit2a','limit2a');
			$markerArray["###LIMIT2B###"] = $this->pi_getLL('limit2b','limit2b');
			$markerArray["###SECONDS###"] = $this->pi_getLL('seconds','seconds');
			$markerArray["###MINUTES###"] = $this->pi_getLL('minutes','minutes');
		}		
		// Link to the Highscore list
  		$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "score", "tx_myquizpoll_pi1[qtuid]" => $quizData["qtuid"], "no_cache" => "1");
		$markerArray["###HIGHSCORE_URL###"] = $this->pi_linkToPage($this->pi_getLL('highscore_url','highscore_url'), $listPID, $target = '', $urlParameters);
		
		// Jokers
		if ($this->conf['useJokers'] && $this->conf['pageQuestions']==1) {
			/*
			*  Instantiate the xajax object and configure it
			*/
			require_once (t3lib_extMgm::extPath('xajax') . 'class.tx_xajax.php');		// Include xaJax
			$this->xajax = t3lib_div::makeInstance('tx_xajax'); // Make the instance
			# $this->xajax->setRequestURI('xxx'); 		// nothing to set, we send to the same URI
			# $this->xajax->decodeUTF8InputOn(); // Decode form vars from utf8 ???
			# $this->xajax->setCharEncoding('utf-8'); // Encode of the response to utf-8 ???
			$this->xajax->setWrapperPrefix($this->prefixId); // To prevent conflicts, prepend the extension prefix
			$this->xajax->statusMessagesOff(); // Do you wnat messages in the status bar?
			$this->xajax->debugOff(); // Turn only on during testing
			$this->xajax->registerFunction(array('getAjaxData', &$this, 'getAjaxData')); // Register the names of the PHP functions you want to be able to call through xajax - $xajax->registerFunction(array('functionNameInJavascript', &$object, 'methodName'));
			$this->xajax->processRequests();// If this is an xajax request, call our registered function, send output and exit
			$GLOBALS['TSFE']->additionalHeaderData[$this->prefixId] = $this->xajax->getJavascript(t3lib_extMgm::siteRelPath('xajax'));// Else create javascript and add it to the header output
			
			$markerArrayJ=array();
			$markerArrayJ["###PREFIX###"] = $this->prefixId;
			$markerArrayJ["###USE_JOKERS###"] = $this->pi_getLL('use_jokers','use_jokers');
			$markerArrayJ["###ANSWER_JOKER###"] = $this->pi_getLL('answer_joker','answer_joker');			
		}

		// Init
		$no_rights = 0;			// second entry of the quiz taker or not logged in if requiered?
//		$leftQuestions = 0;		// no. of questions to be shown
		$whereAnswered = '';	// questions that have been allready answered (UIDs)
		$whereSkipped = '';		// questions that have been skipped (UIDs)
		$content = '';			// content to be shown
		$tableQuestions = 'tx_myquizpoll_question';
		$tableAnswers   = 'tx_myquizpoll_result';
		$tableRelation  = 'tx_myquizpoll_relation';
		$tableCategory  = 'tx_myquizpoll_category';

		$helperObj = new tx_myquizpoll_helper(
			$thePID, 
			$this->lang,
			$this->answerChoiceMax,
			$tableQuestions, 
			$tableAnswers, 
			$tableRelation, 
			$this->conf
		);
		$helperObj->addDebug('Language: '.$this->lang);
		
		// set some session-variables
		if ((!$this->conf['isPoll']) && ($quizData["cmd"]=='') && (!$quizData["qtuid"]))
			$helperObj->setQuestionsVars();
		
		// check, if logged in
		if ( $this->conf['loggedInCheck'] && $quizData["cmd"]!='score' && !$GLOBALS['TSFE']->loginUser ) {
			$no_rights = 1;					// noname user is (b)locked now
			$markerArray["###NOT_LOGGEDIN###"] = $this->pi_getLL('not_loggedin','not_loggedin');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NOT_LOGGEDIN###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArray);  	// Sonderfall !!!
			$helperObj->addDebug('Loggin check.');
		}

		// check for second entry ( based on the ip-address )
		if ( $this->conf['doubleEntryCheck'] && $quizData["cmd"]!='score' && !$quizData["qtuid"] && $no_rights == 0 ) {
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery( 'tstamp, uid',
															$tableAnswers,
															'pid='.$resPID." AND ip='".$quiz_taker_ip_address."' AND sys_language_uid=".
																$this->lang.' '.$this->cObj->enableFields($tableAnswers),
															'',
															'tstamp DESC',
															'1');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {							// DB entry found for current user?
				$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
				$dateOld = $fetchedRow['tstamp'];
				$period = intval($this->conf['doubleEntryCheck']);	// seconds
				if ($period < 10000) $period *= 60*60*24;		// days
				//if ($period==1) $period = 50000;		// approx. a half day is the quiz blocked for the same ip-address
				if ((time() - $dateOld) < $period) {
					if ( $this->conf['doubleCheckMode'] ) {
						$quizData["qtuid"] = $fetchedRow['uid'];
						$quizData["cmd"]  = 'next';
					} else {
						$no_rights = 1;						// user is (b)locked now
						$markerArray["###DOUBLE_ENTRY###"] = $this->pi_getLL('double_entry','double_entry');
						$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_DOUBLE_ENTRY###");
						$content .= $this->cObj->substituteMarkerArray($template, $markerArray);		 // Sonderfall !!!
					}
				}
			}
			$helperObj->addDebug('IP check.');
		}
		
		// check for second entry ( based on the fe_users-id )
		if ( $this->conf['loggedInMode'] && $quizData["cmd"]!='score' && !$quizData["qtuid"] && $GLOBALS['TSFE']->loginUser && $no_rights == 0 ) {
			$fe_uid = intval($GLOBALS['TSFE']->fe_user->user['uid']);
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery( 'uid, tstamp',
															$tableAnswers,
															'pid='.$resPID." AND fe_uid=$fe_uid AND sys_language_uid=".
																$this->lang.' '.$this->cObj->enableFields($tableAnswers),
															'',
															'tstamp DESC',
															'1');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {							// DB entry found for current user?
				$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
				if ( $this->conf['doubleCheckMode'] ) {
					$quizData["qtuid"] = $fetchedRow['uid'];
					$quizData["cmd"]  = 'next';
				} else {
					$no_rights = 1;						// user is (b)locked now
					$markerArray["###DOUBLE_ENTRY###"] = $this->pi_getLL('double_entry','double_entry');
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_DOUBLE_ENTRY###");
					$content .= $this->cObj->substituteMarkerArray($template, $markerArray);		 // Sonderfall !!!
				}
			}
			$helperObj->addDebug('fe_users check.');
		}
		
		// check if the captcha is OK
		if (($quizData["cmd"]  == 'submit' || $quizData["fromStart"]) && is_object($this->freeCap) && ($this->conf['enableCaptcha']==1 || ($this->conf['enableCaptcha']==2 && $quizData["fromStart"])) && !$this->freeCap->checkWord($quizData['captcha_response']) && $no_rights == 0) {
			if ($quizData["fromStart"] && $startPID!=$GLOBALS["TSFE"]->id) {	// Weiterleitung zurueck zur Extra-Startseite
				$this->redirectUrl($startPID, array($this->prefixId.'[name]' => $quizData["name"],$this->prefixId.'[email]' => $quizData["email"],$this->prefixId.'[homepage]' => $quizData["homepage"], $this->prefixId.'[captchaError]' => '1'));
				break;	// hier kommt man eh nie hin...
			}
			$quizData["cmd"]  = ($quizData["fromStart"]) ? '' : 'next';		// "nochmal" simulieren
			//$quizData["qtuid"] = '';		// wieso wohl???
			$markerArray["###CAPTCHA_NOT_OK###"] = $this->pi_getLL('captcha_not_ok','captcha_not_ok');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CAPTCHA_NOT_OK###");
			$markerArrayP["###REF_ERRORS###"] .= $this->cObj->substituteMarkerArray($template, $markerArray);	// instead of $content
			if ($quizData["fromStart"]) $quizData["fromStart"] = 0;			// nichts wurde getan simulieren
			$helperObj->addDebug('captcha check.');
			$error=true;
		} else if ($quizData["captchaError"]) {
			$markerArray["###CAPTCHA_NOT_OK###"] = $this->pi_getLL('captcha_not_ok','captcha_not_ok');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CAPTCHA_NOT_OK###");
			$markerArrayP["###REF_ERRORS###"] .= $this->cObj->substituteMarkerArray($template, $markerArray);	// instead of $content
			$helperObj->addDebug('captcha check.');
			$error=true;
		}
		
		// read quiz takers old data
		$answeredQuestions = '';     // prev. answered Question(s)
		$skipped = '';
		$cids = '';
		$fids = '';
		if ((($this->conf['useCookiesInDays']>0 && !$quizData["qtuid"]) || 
			 ($quizData["cmd"]  == 'next') ||
			 ($quizData["cmd"]  == 'submit' && !$this->conf['isPoll'] && (!$this->conf['dontShowPoints'] || $this->conf['quizTimeMinutes']))) && $no_rights == 0 ) {
			 
			if (!$quizData["qtuid"] && $this->conf['useCookiesInDays']>0) {   // !($quizData["cmd"]  == 'next' || $quizData["cmd"]  == 'submit')) warum das nur? auskommentiert am 27.12.2009
				if ($this->conf['cookieMode']==1)
					$cookieName = "myquizpoll".$resPID.'_'.$this->lang;
				else if ($this->conf['cookieMode']==2 && $GLOBALS['TSFE']->fe_user->user['uid'])
					$cookieName = "myquizpoll".$resPID.'_'.$GLOBALS['TSFE']->fe_user->user['uid'];
				else
					$cookieName = "myquizpoll".$resPID;
				$quizData["qtuid"] = $_COOKIE[$cookieName];	// read quiz taker UID and from a cookie
				$helperObj->addDebug('Cookie read: '.$cookieName.'='.$quizData["qtuid"]);
			// oder? $HTTP_COOKIE_VARS["myquizpoll".$resPID];    oder?  $GLOBALS["TSFE"]->fe_user->getKey("ses","myquizpoll".$resPID);
			}
			
			if ($quizData["qtuid"]) {	// load solved questions and quiz takers name, email, homepage, old points and last time
				$uid = intval($quizData["qtuid"]);
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('name, email, homepage, qids,sids,cids,fids, p_or_a, p_max, percent, o_max, o_percent, firsttime, joker1,joker2,joker3, nextcat',
					$tableAnswers,
					'uid='.$uid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if ($rows>0) {							// DB entry found for current user?
					$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
					$answeredQuestions = $fetchedRow['qids'];
					$skipped = $fetchedRow['sids'];
					$joker1 = $fetchedRow['joker1'];
					$joker2 = $fetchedRow['joker2'];
					$joker3 = $fetchedRow['joker3'];
					$firsttime = intval($fetchedRow['firsttime']);
					$helperObj->setFirstTime($uid, $firsttime);
					if ($answeredQuestions && !$this->conf["isPoll"]) {
						if ($fetchedRow['nextcat']) $this->conf['startCategory'] = $fetchedRow['nextcat'];	// kategorie der naechsten frage...
						if ($quizData["cmd"]  != 'submit') {			// namen nicht ueberschreiben
							$whereAnswered = ' AND uid NOT IN ('.$answeredQuestions.')';	// exclude answered questions next time
							$quizData["name"] = $fetchedRow['name'];
							$quizData["email"] = $fetchedRow['email'];
							$quizData["homepage"] = $fetchedRow['homepage'];
						}
						$markerArray["###VAR_TOTAL_POINTS###"] = intval($fetchedRow['p_or_a']);		// save total points for the case there are no more questions
						$markerArray["###VAR_TMAX_POINTS###"] = intval($fetchedRow['p_max']);
						$markerArray["###VAR_TMISSING_POINTS###"] = intval($fetchedRow['p_max']) - intval($fetchedRow['p_or_a']);
						$markerArray["###VAR_PERCENT###"] = intval($fetchedRow['percent']);
						$markerArray["###VAR_OMAX_POINTS###"] = intval($fetchedRow['o_max']);
						$markerArray["###VAR_OVERALL_PERCENT###"] = intval($fetchedRow['o_percent']);
						$markerArray["###VAR_QUESTIONS_ANSWERED###"] = (($fetchedRow['qids']) ? (substr_count($fetchedRow['qids'],',')+1) : 0);
						if ($fetchedRow['cids'] || $fetchedRow['fids']) {	// if weglassen?
							$markerArray["###VAR_QUESTIONS_CORRECT###"] = (($fetchedRow['cids']) ? (substr_count($fetchedRow['cids'],',')+1) : 0);
							$markerArray["###VAR_QUESTIONS_FALSE###"] = (($fetchedRow['fids']) ? (substr_count($fetchedRow['fids'],',')+1) : 0);
						}
						$elapseTime = time() - $firsttime;
					}
					if ($skipped && !$this->conf["isPoll"] && $quizData["cmd"]  != 'submit') {
						$whereSkipped = ' AND uid NOT IN ('.$skipped.')';	// exclude skipped questions next time
					}
				}
			} else if ($this->conf['quizTimeMinutes'] && $quizData["time"]) {
				$elapseTime = time() - intval($quizData["time"]);		// before saving data
			}
			$helperObj->addDebug("old data loaded: $answeredQuestions / $whereAnswered / $whereSkipped");
		}
		
		// check, if quiz is cancled
		if ( $this->conf['quizTimeMinutes'] && ((intval($this->conf['quizTimeMinutes'])*60 - $elapseTime)<=0) ) {     // oder $quizData['cancel'] == 1 ) {
			$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
			$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
			$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
			$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
			$markerArray["###QUIZ_END###"] = $this->pi_getLL('quiz_end','quiz_end');
			$markerArray["###RESTART_QUIZ###"] = $this->pi_linkToPage($this->pi_getLL('restart_quiz','restart_quiz'), $startPID, $target = '', array());
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_END###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArray);		// sonderfall !!!
			
			if ( $this->conf['finalWhenCancel'] ) {
				$noQuestions = true;
			} else {
				if ( $this->conf['showHighscore'] ) {
					$quizData["cmd"] = 'score';		// show highscore
				} else {
					$quizData["cmd"] = 'exit';		// display no more questions
				}
				$no_rights = 1;					// cancel all				
			}
			$helperObj->addDebug('cancel check.');
		}
		
		$catArray = array();
		//if ($this->conf['startCategory']) {		// Kategorie-Namen zwischenspeichern
			$res6 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,name',
					$tableCategory,
					'pid='.$thePID,
					'',
					'',
					'');
			$rows6 = $GLOBALS['TYPO3_DB']->sql_num_rows($res6);
			if ($rows6>0) {
				while($row6 = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res6)){ 
					$catUID = $row6['uid'];
					$catArray[$catUID] = $row6['name'];
				}
			}
		//}
		
		// show only a start page?
		if ($this->conf['userData.']['askAtStart'] && !$quizData["qtuid"] && !$quizData["cmd"] && !$quizData["fromStart"]) {		// show only "ask for user data"?
			$startPage = true;
			$quizData["cmd"] = 'start';
		}
		
		// next page is a page with questions...
		if ($quizData["cmd"] == 'next') {
			$quizData["cmd"] = '';
		}
		
		
		if( $quizData["cmd"] == 'submit' && $no_rights == 0 ) {   /* ***************************************************** */
			/*
			 * Display result page: answers and points
			 */

			// Check quiz taker name and email
			if ( trim($quizData["name"]) == "" ) {
				$quizData["name"] = $this->pi_getLL('no_name','no_name');
			}
			if ( !(t3lib_div::validEmail(trim($quizData["email"]))) ) {
				$quizData["email"] = $this->pi_getLL('no_email','no_email');
			}

			// Avoid bad characters in database request
			$quiz_taker_name = $GLOBALS['TYPO3_DB']->quoteStr($quizData["name"], $tableAnswers); //addslashes($quizData["name"]);
			$quiz_taker_email  = $GLOBALS['TYPO3_DB']->quoteStr($quizData["email"], $tableAnswers); //addslashes($quizData["email"]);
			$quiz_taker_homepage = $GLOBALS['TYPO3_DB']->quoteStr($quizData["homepage"], $tableAnswers); //addslashes($quizData["homepage"]);
			
			$markerArray["###REAL_NAME###"] = $quiz_taker_name;
			$markerArray["###REAL_EMAIL###"] = $quiz_taker_email;
			$markerArray["###REAL_HOMEPAGE###"] = $quiz_taker_homepage;
			$markerArray["###RESULT_FOR###"] = $this->pi_getLL('result_for','result_for');
			$markerArray["###THANK_YOU###"] = $this->pi_getLL('thank_you','thank_you');
			$markerArray["###RES_QUESTION_POINTS###"] = $this->pi_getLL('result_question_points','result_question_points');
			if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
				$markerArray["###P1###"] = $this->pi_getLL('p1','p1');
				$markerArray["###P2###"] = $this->pi_getLL('p2','p2');
			} else {
				$markerArray["###P1###"] = '';
				$markerArray["###P2###"] = '';
			}
			$markerArray["###VAR_QUESTIONS###"] = $helperObj->getQuestionsNo();
			if ($whereAnswered)
				$markerArray["###VAR_QUESTION###"] = $helperObj->getQuestionNo($whereAnswered);
			else
				$markerArray["###VAR_QUESTION###"] = $helperObj->getQuestionNo('-');
				
			if ( $quiz_taker_email==$this->pi_getLL('no_email','no_email') ) {
				$quiz_taker_email='';
			}
			if ( $quiz_taker_homepage==$this->pi_getLL('no_homepage','no_homepage') ) {
				$quiz_taker_homepage='';
			}
			
			
			// Begin HTML output
			$template_qr = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QRESULT###"); // full template
			$template_answer = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR###");
			$template_okok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_ANSW###");
			$template_oknot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_NOTANSW###");
			$template_notok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_ANSW###");
			$template_notnot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_NOTANSW###");
			$template_qr_points = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_POINTS###");
			$template_expl = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_EXPLANATION###");
			$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");
			$template_image_begin = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_BEGIN###");
			$template_image_end = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_END###");
			
			// Get the answers from the user
			$answerArray = array();
			$questionNumber = 1;
			$lastUIDs = '';
			$whereUIDs = '';
			while( $quizData['uid'.$questionNumber] ) {
				$answerArray[$questionNumber] = $quizData['uid'.$questionNumber];
				$lastUIDs .= ','.$quizData['uid'.$questionNumber];
				$questionNumber++;
			}
			$maxQuestions = $questionNumber-1;
			if ($lastUIDs) {
				$whereUIDs = ' AND uid IN ('.substr($lastUIDs,1).')';
			}
			
			// Get questions from the database
			$questionsArray = array();
			$tempNumber = 0;
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
					$tableQuestions,
					'pid='.$thePID.$whereUIDs.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
					'',
					'',
					'');		// alles aus der DB holen, auch was nicht gebraucht wird :-(
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
					$tempNumber = $row['uid'];			// save the uid for each question
					$questionsArray[$tempNumber] = $row; 	// save each question
				}
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res5); 
			
			$points=0;				// points from the user (quiz taker)
			$maxPoints=0;			// maximum points reachable per page
			$maxTotal=0;			// maximum total points reachable
			$percent=0;				// 100 * reached points / total points
			$overallMaximum = 0;	// overall points of all questions
			$overallPercent = 0;	// overall percent
			$questionUID=0;			// uid of a question
			$answered='';			// uids of answered questions
			$skipped='';			// uids of skipped questions
			$correctAnsw = '';		// uids of correct answered question
			$falseAnsw = '';		// uids of false answered question
			$skippedCount = 0;		// no. of skipped questions at this page
			$imgTSConfig = Array();	// image values
			if (is_array($this->conf['jokers.']))
				$halvePoints = $this->conf['jokers.']['halvePoints'];
			else
				$halvePoints = 0;
			
			// Old questions and answers
			for( $questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++ ) {
				$questionUID = $answerArray[$questionNumber]; 
				$row = $questionsArray[$questionUID];
				
				if ($this->conf['isPoll']) {	// link to the result page    && $this->conf['showPollResultLink']
					$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "list", "tx_myquizpoll_pi1[qid]" => $questionUID, "no_cache" => "1");
					$markerArray["###POLLRESULT_URL###"] = $this->pi_linkToPage($this->pi_getLL('poll_url','poll_url'), $listPID, $target = '', $urlParameters);
				} else if ($quizData['answer'.$questionNumber]==-1) {
					$skipped.=','.$questionUID;
					$skippedCount++;
					continue;
				}
				
				//$answerPointsBool = false;
				$answered.=','.$questionUID;		// nach unten geschoben...
				$questionPoints=0;
				$maxQuestionPoints=0;
				$markerArray["###VAR_QUESTION###"]++;
				$nextCat = '';
				$lastCat = $row['category'];
				if ($catArray[$lastCat]) $markerArray["###VAR_CATEGORY###"] = $catArray[$lastCat];
				
				// Output the result/explanations
				if ( !($this->conf['dontShowCorrectAnswers'] && $this->conf['dontShowPoints']) || $this->conf['startCategory'] || $this->conf['advancedStatistics'] || $this->conf['showAllCorrectAnswers'] || $this->conf['isPoll'] ) {
				
					if ($row['image'] && (substr_count($template_qr, 'REF_QUESTION_IMAGE_BEGIN')>0)) {
						$imgTSConfig['file'] = 'uploads/tx_myquizpoll/'.$row['image']; //The image field name
						$imgTSConfig['altText'] = $row["alt_text"];
						$imgTSConfig['titleText'] = $row["alt_text"];
						if (is_array($this->conf['images.'])) {
							$imgTSConfig['file.']['maxW'] = $this->conf['images.']['maxW'];
							$imgTSConfig['file.']['maxH'] = $this->conf['images.']['maxH'];
						}
						//$this->conf["image."]["file"] = 'uploads/tx_myquizpoll/'.($row['image']); //The image field name
						$markerArray["###VAR_QUESTION_IMAGE###"] = $this->cObj->IMAGE($imgTSConfig);	// statt $this->conf["image."]
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = $this->cObj->substituteMarkerArray($template_image_begin, $markerArray);
						$markerArray["###REF_QUESTION_IMAGE_END###"] = $template_image_end;
					} else {
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = '';
						$markerArray["###REF_QUESTION_IMAGE_END###"] = '';
					}
					$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
					$markerArray["###VAR_QUESTION_NAME###"] = $this->formatStr($this->local_cObj->stdWrap($row['name'],$this->conf["general_stdWrap."])); // $this->pi_RTEcssText($row['name']);
					$markerArray["###REF_QR_ANSWER_ALL###"] = '';
					$markerArray["###REF_QR_ANSWER_CORR###"] = '';
					$markerArray["###REF_QR_ANSWER_CORR_ANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_NOTCORR_ANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_NOTCORR_NOTANSW###"] = '';
					$markerArray["###REF_QR_POINTS###"] = '';
					$markerArray["###VAR_QUESTION_ANSWER###"] = '';
					$markerArray["###VAR_ANSWER_POINTS###"] = '';
					$markerArray["###VAR_QUESTION_POINTS###"] = '';
					$markerArray["###VAR_MAX_QUESTION_POINTS###"] = '';
					$markerArray["###REF_QR_EXPLANATION###"] = '';
					$markerArray["###REF_DELIMITER###"] = '';
					if ( $this->conf['dontShowPoints'] )
						$markerArray["###NO_POINTS###"] = '';
					else
						$markerArray["###NO_POINTS###"] = '0';
					
					if ( !$this->conf['isPoll'] ) {
					/*	if ($this->conf['noNegativePoints']<3) {		// 20.01.10: wenn alle antworten richtig sein muessen, antwort-punkte ignorieren!
							for ($currentValue=1; $currentValue <= $this->answerChoiceMax; $currentValue++) {
								if (intval($row['points'.$currentValue])>0 ) {
									$answerPointsBool = true;
									break;		// Punkte bei Antworten gefunden...
								}
							}
						}  am 21.01.10 auskommentiert! */
					} else {
						$points=$quizData['answer'.$questionNumber];						// points = SELECTED ANSWER !!!
						$markerArray["###VAR_USER_ANSWER###"] = $row['answer'.$points];
                        if ($points>0 && $this->conf['startCategory'] && $row['category'.$points]) {    // NEUUUU
                            $nextCat = $row['category'.$points];    // next category from an answer
                        } 
						break;		// mehr braucht man nicht bei Umfragen
					}
					
					if (is_array($this->conf['myVars.']['questions.'])) {
						foreach($this->conf['myVars.']['questions.'] as $key => $value) {
							$myQArray = split(',', $value);
							$myKey = ($questionNumber-1)%count($myQArray);
							$markerArray["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
						}
					}
					
					$allAnswersOK = true;	// alle Antworten richtig beantwortet?
					$correctBool = false;	// gibt es ueberhaupt korrekte antworten?
					
					for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
						
						if ($row['answer'.$answerNumber] || $row['answer'.$answerNumber]==='0' || $row['qtype']==5) {	// was a answer set in the backend?
							
							$selected=0;	// was the answer selected by the quiz taker?
							$tempAnswer = ''; // text for answer $answerNumber
							if (is_array($this->conf['myVars.']['answers.'])) {						// custom variables
								foreach($this->conf['myVars.']['answers.'] as $key => $value) {
									$myAArray = split(',', $value);
									$myKey = ($answerNumber-1)%count($myAArray);
									$markerArray["###MY_".strtoupper($key)."###"] = $myAArray[$myKey];
								}
							}
							
							//if ( !$this->conf['isPoll'] ) {	// show correct answers. Bug fixed: dontShowCorrectAnswers doesnt matter here
								if ( !$this->conf['dontShowCorrectAnswers'] )
									$markerArray["###VAR_QUESTION_ANSWER###"] = $row['answer'.$answerNumber];
								
								$answerPoints = 0;		// answer points from the DB
								if ( !$this->conf['dontShowPoints'] ) {
									//if ($answerPointsBool) { 		// hier interessiert es nicht, ob eine Antwort als korrekt markiert wurde!
									if ($this->conf['noNegativePoints']<3)	// das ganze Verhalten am 21.01.10 geaendert...
										$answerPoints = intval($row['points'.$answerNumber]);
									if ($answerPoints > 0) {
										$row['correct'.$answerNumber] = true;		// ACHTUNG: falls Punkte zu einer Antwort gesetzt sind, dann wird die Antwort als RICHTIG bewertet!
									} else {
										$answerPoints = intval($row['points']);
									}
									if ($row['correct'.$answerNumber] || $row['qtype']==3) {
										if (($row['qtype'] == 0 || $row['qtype'] == 4) && $this->conf['noNegativePoints']<3)  // KGB, 20.01.10: weg: !$answerPointsBool || $row['qtype'] >= 3, neu: $this->conf['noNegativePoints']<3
											$maxQuestionPoints+=$answerPoints;
										else if ($answerPoints > $maxQuestionPoints)
											$maxQuestionPoints=$answerPoints;	// bei punkten pro antwort ODER wenn nicht addiert werden soll
									}
									$markerArray["###VAR_ANSWER_POINTS###"] = $answerPoints;
								}
								
								if ($quizData['answer'.$questionNumber.'_'.$answerNumber]) {  // !='') {	// type 0 und 4
									$selected=$answerNumber; 
								} else if ($row['qtype']>0 && $row['qtype']<3 && $quizData['answer'.$questionNumber]==$answerNumber) {
									$selected=$answerNumber;
								} else if (($row['qtype']==3 && $quizData['answer'.$questionNumber]!='') || $row['qtype']==5) {	// type 3 und 5
									$selected=$answerNumber;			// sollte 1 sein
								}
							//}
							
							$wrongText = 0;		// wrong text input?
							
/*							if ($this->conf['isPoll']) {	// wurde aus der Schleife genommen!
								$points=$quizData['answer'.$questionNumber];						// points = SELECTED ANSWER !!!
								$markerArray["###VAR_USER_ANSWER###"] .= $row['answer'.$points];
							} else */
							if ($row['qtype']==5 && !$this->conf['dontShowCorrectAnswers']) {
								$markerArray["###VAR_QUESTION_ANSWER###"] = $quizData['answer'.$questionNumber];
								$tempAnswer = $this->cObj->substituteMarkerArray($template_okok, $markerArray);
								$markerArray["###REF_QR_ANSWER_CORR_ANSW###"] .= $tempAnswer;	// welches template soll man hier wohl nehmen?
							} else if ($selected>0 && (($row['qtype']==3 && strtolower($row['answer'.$answerNumber])==strtolower($quizData['answer'.$questionNumber])) ||
												($row['qtype']!=3 && $row['correct'.$answerNumber]))) {	// korrekte Antwort
								$questionPoints=$questionPoints+$answerPoints;	// $row['points']; geaendert am 16.9.2009
								if ( !$this->conf['dontShowCorrectAnswers'] ) {
									$tempAnswer = $this->cObj->substituteMarkerArray($template_okok, $markerArray);
									$markerArray["###REF_QR_ANSWER_CORR_ANSW###"] .= $tempAnswer;
								}
								$correctBool = true;
							} else if ($selected>0) {	// falsche Antwort
								$allAnswersOK = false;
								if ($this->conf['noNegativePoints']!=2)
									$questionPoints=$questionPoints-$answerPoints;	// $row['points']; geaendert am 16.9.2009
								if ( !$this->conf['dontShowCorrectAnswers'] ) {		 // { added 8.8.09
									if ($row['qtype']==3) {		// since 0.1.8: falsche und richtige antwort ausgeben
										$tempAnswer = $this->cObj->substituteMarkerArray($template_oknot, $markerArray);
										$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] .= $tempAnswer;
										$markerArray["###VAR_QUESTION_ANSWER###"] = $quizData['answer'.$questionNumber];										
									}
									$tempAnswer2 = $this->cObj->substituteMarkerArray($template_notok, $markerArray);
									$markerArray["###REF_QR_ANSWER_NOTCORR_ANSW###"] .= $tempAnswer2;
									$tempAnswer .= $tempAnswer2;	// hier gibt es 2 antworten !!!
								}
								if ($row['qtype']==3) $wrongText=1;		// for statistics: a2 statt a1 bei falscher antwort
							} else if ($row['correct'.$answerNumber]) {	// nicht beantwortet, waere aber richtig gewesen
								$allAnswersOK = false;
								if (!$this->conf['dontShowCorrectAnswers']) {		// hierhin verschoben am 24.1.10
									$tempAnswer = $this->cObj->substituteMarkerArray($template_oknot, $markerArray);
									$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] .= $tempAnswer;
								}
								if ($row['qtype']==3) {
									$wrongText=1;		// for statistics: a2 statt a1 bei falscher antwort
									$selected=2;		// statistics: no answer = false answer !
								}
								$correctBool = true;
							} else if ( !$this->conf['dontShowCorrectAnswers'] ) {
								$tempAnswer = $this->cObj->substituteMarkerArray($template_notnot, $markerArray);
								$markerArray["###REF_QR_ANSWER_NOTCORR_NOTANSW###"] .= $tempAnswer;
							}
							
							if (!$this->conf['dontShowCorrectAnswers']) {	// !$this->conf['isPoll'] && 
								$markerArray["###REF_QR_ANSWER_ALL###"] .= $tempAnswer;		// all answers in correct order
								if ($row['correct'.$answerNumber] || $row['qtype']==3 || $row['qtype']==5) {	// all correct answers
									$markerArray["###REF_QR_ANSWER_CORR###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
								}
							}
							
							if ($this->conf['advancedStatistics']) {			// for more statistics  && !$this->conf['isPoll']
								$statisticsArray[$questionUID]['a'.($answerNumber+$wrongText)] = ($selected>0) ? 1 : 0;
								if (($row['qtype']==3 || $row['qtype']==5) && ($quizData['answer'.$questionNumber] || $quizData['answer'.$questionNumber]==='0')) {
									$statisticsArray[$questionUID]['text'] = $GLOBALS['TYPO3_DB']->quoteStr($quizData['answer'.$questionNumber], $tableRelation);
								} else {
									$statisticsArray[$questionUID]['text'] = '';
								}
							}
							
							if ($selected>0 && $this->conf['startCategory'] && $row['category'.$selected]) {
								$nextCat = $row['category'.$selected];	// next category from an answer
							}
							
						}
						if ($row['qtype']==5) break 1;	// nur erste Antwort ist hier moeglich
					}
					
					if ( $this->conf['startCategory'] && !$nextCat) {
						$nextCat = $row['category_next'];	// next category of this question
					}
					
					if (!$this->conf['dontShowPoints']) {		// Bug fixed: dontShowCorrectAnswers doesnt matter here  && !$this->conf['isPoll']
						if ($questionPoints<0 && $this->conf['noNegativePoints'])
							$questionPoints=0;		// keine neg. Punkte
						if ($questionPoints>0 && $this->conf['noNegativePoints']==3) {
							if (!$allAnswersOK)
								$questionPoints=0;		// keine Punkte, wenn eine Antwort falsch war
							else
								$questionPoints=$answerPoints;		// KGB, 19.01.10: nur maximale Punkte vergeben, nicht pro Antwort
						}
						if ($this->conf['noNegativePoints']==4) {	// Punkte nur, wenn alles OK war
							if ($allAnswersOK)
								$questionPoints=0;
							else
								$questionPoints=$answerPoints;
						}
						if ($questionPoints>0 && $halvePoints && ($quizData["joker1"] || $quizData["joker2"] || $quizData["joker3"]))
							$questionPoints = intval($questionPoints/2);	// halbe Punkte nach Joker-Benutzung	
						
						$points+=$questionPoints;
						$maxPoints+=$maxQuestionPoints;
						
						if ($this->conf['advancedStatistics'])
							$statisticsArray[$questionUID]['points'] = $questionPoints;
					} else if ($this->conf['advancedStatistics'])
							$statisticsArray[$questionUID]['points'] = 0;
					
					if ($correctBool) {		// falls es richtige antworten gibt, merken welche man richtig/falsch beantwortet hat
						if ($allAnswersOK)
							$correctAnsw .= ','.$questionUID;
						else
							$falseAnsw .= ','.$questionUID;
					}
					
					if (!$this->conf['dontShowCorrectAnswers']) {	//  && !$this->conf['isPoll']
						if (!$this->conf['dontShowPoints']) {
							$markerArray["###VAR_QUESTION_POINTS###"] = $questionPoints;
							$markerArray["###VAR_MAX_QUESTION_POINTS###"] = $maxQuestionPoints;
							$markerArray["###REF_QR_POINTS###"] = $this->cObj->substituteMarkerArray($template_qr_points, $markerArray);
						}
						
						if ( $row['explanation']!='' ) {	// Explanation
							$markerArray["###VAR_EXPLANATION###"] = $this->formatStr($this->local_cObj->stdWrap($row['explanation'],$this->conf["general_stdWrap."]));
							$markerArray["###REF_QR_EXPLANATION###"] = $this->cObj->substituteMarkerArray($template_expl, $markerArray);
						}
					
						$markerArray["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArray);
					}
				}
				if (!$this->conf['dontShowCorrectAnswers']) {	// bug fixed: points dont even matter  && !$this->conf['isPoll']
					$markerArrayP["###REF_QRESULT###"] .= $this->cObj->substituteMarkerArray($template_qr, $markerArray);
				}
			}
			
			if ( $this->conf['isPoll'] ) {		// ab hier kommt die Umfrage erst wieder zum Zug
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLL_SUBMITED###");	// Output thank you
				$markerArray['###QUESTION_NAME###'] = $this->pi_getLL('poll_question','poll_question');
				$markerArray['###USER_ANSWER###'] = $this->pi_getLL('poll_answer','poll_answer');
				$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);  // instead $content
			} else if ( $this->conf['userData.']['showAtAnswer'] ) { // !$this->conf['dontShowUserData'] && !$this->conf['dontShowUserResult'] ) {	nicht mehr seit 0.4.0
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_SUBMITED###"); // Output the user name
				$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
			}
			
			if ($answered) $answered=substr($answered,1);	// now answered questions (UIDs)
			if ($skipped) $skipped=substr($skipped,1);	// now skipped questions (UIDs)
			if ($correctAnsw) $correctAnsw=substr($correctAnsw,1);
			if ($falseAnsw) $falseAnsw=substr($falseAnsw,1);
			
			$doUpdate=0;					// insert or update?
			$pointsTotal=$points;			// total points, reached
			$maxTotal = $maxPoints;			// total points, maximum
			
			//if ($this->conf['pageQuestions'] > 0 && !$this->conf['isPoll']) {	// more questions aviable? // auskommentiert am 27.12.2009, denn der Cheat-Test muss immer kommen!
			
				if (!$this->conf['showAnswersSeparate'])
					$quizData["cmd"] = '';						// show more/next questions!
				// Seek for old answered questions
				if ($quizData["qtuid"]) {
					$uid = intval($quizData["qtuid"]);
					$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('qids,cids,fids,sids, p_or_a, p_max, joker1,joker2,joker3',
						$tableAnswers,
						'uid='.$uid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
						'',
						'',
						'');
					$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
					if ($rows>0) {							// DB entry found for current user?
						$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
						$answeredOld = $fetchedRow['qids'];
						$correctOld = $fetchedRow['cids'];
						$falseOld = $fetchedRow['fids'];
						$skippedOld = $fetchedRow['sids'];
						$pointsOld = $fetchedRow['p_or_a'];
						$maxPointsOld = $fetchedRow['p_max'];
						$joker1 =  $fetchedRow['joker1'];
						$joker2 =  $fetchedRow['joker2'];
						$joker3 =  $fetchedRow['joker3'];
						if ($correctOld && $correctAnsw) 
							$correctAnsw .= ','.$correctOld; 
						else if ($correctOld)
							$correctAnsw = $correctOld;		
						if ($falseOld && $falseAnsw) 
							$falseAnsw .= ','.$falseOld;
						else if ($falseOld)
							$falseAnsw = $falseOld;
						if (!$answered) {				// all questions skipped  # Fall 1: bisher nur geskipped
							$answered = $answeredOld;	// all answered questions
							if ($skippedOld && $skipped) 
								$skipped .= ','.$skippedOld; 
							else if ($skippedOld)
								$skipped = $skippedOld;				
							$pointsTotal = $pointsOld;	// total points
							$maxTotal = $maxPointsOld;
							//if ($answeredOld) $doUpdate=1;
							$doUpdate = 3;
						} else if (stristr(','.$answeredOld.',', ','.$answered.',')) {  // Fall 2: somebody tries to cheat! Bug fixed: ',' matters
							$answered = $answeredOld;	// all answered questions
							$skipped = $skippedOld;		// all skipped questions
							$pointsTotal = $pointsOld;	// total points
							$maxTotal = $maxPointsOld;
							$doUpdate = 2;
							$error = true;
							$markerArray["###CHEATING###"] = $this->pi_getLL('cheating','cheating');
							$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CHEATING###");
							$markerArrayP["###REF_RES_ERRORS###"] .= $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
							/*$tempTime = $helperObj->getPageTime($quizData["qtuid"]);
							if ($tempTime) {
								$markerArrayP["###VAR_NOW###"] = $markerArray["###VAR_NOW###"] = $tempTime;
							}*/
						} else if ($answeredOld) {			// Fall 3: man hat schon was beantwortet
							$answered .= ','.$answeredOld;	// all answered questions
							if ($skippedOld && $skipped) 
								$skipped .= ','.$skippedOld; 
							else if ($skippedOld)
								$skipped = $skippedOld;
							$pointsTotal = $points + $pointsOld;	// total points
							//$maxTotal = $maxPoints;
							if ($maxPointsOld > 0) $maxTotal = $maxTotal + $maxPointsOld;
							$doUpdate = 1;
						} else if ($skippedOld) {		// Fall 4: skipped, dann beantwortet
							if ($skippedOld && $skipped) 
								$skipped .= ','.$skippedOld; 
							else 
								$skipped = $skippedOld;
							$pointsTotal = $points;	// total points
							$doUpdate = 1;
						}
					}
				}
				
				$whereAnswered = '';
				if ($answered) $whereAnswered = ' AND uid NOT IN ('.$answered.')';	// exclude answered questions next time
				$whereSkipped = '';
				if ($skipped) $whereSkipped = ' AND uid NOT IN ('.$skipped.')';	// exclude skipped questions next time
				
				if ($skippedCount > 0) {
					$markerArray["###VAR_NO###"] = $skippedCount;
					$markerArray["###SKIPPED###"] = $this->pi_getLL('skipped','skipped');
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_SKIPPED###");
					$markerArrayP["###REF_SKIPPED###"] = $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
				}
			
			//} else 
			if (!$this->conf['pageQuestions']) {
				if ( $this->conf['showHighscore'] )
					$quizData["cmd"] = 'score';			// otherwise decide this later
				else
					$quizData["cmd"] = 'nix';		// keine neuen Fragen...
			} else if ( $this->conf['isPoll'] && !$this->conf['dontShowPollResult'] && !$nextCat ) {
				$quizData["cmd"] = 'list';
			}
			
			$markerArray["###VAR_QUESTIONS_ANSWERED###"] = (($answered) ? (substr_count($answered,',')+1) : 0);
			if ($falseAnsw || $correctAnsw) {
				$markerArray["###VAR_QUESTIONS_CORRECT###"] = (($correctAnsw) ? (substr_count($correctAnsw,',')+1) : 0);
				$markerArray["###VAR_QUESTIONS_FALSE###"] = (($falseAnsw) ? (substr_count($falseAnsw,',')+1) : 0);
			}

			if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {	// Total points yet. && !$this->conf['dontShowCorrectAnswers'] ??
				$markerArray["###RESULT_POINTS###"] = $this->pi_getLL('result_points','result_points');
				$markerArray["###TOTAL_POINTS###"] = $this->pi_getLL('total_points','total_points');
				$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
				$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
				$markerArray["###VAR_RESULT_POINTS###"] = $points;
				$markerArray["###VAR_MAX_POINTS###"] = $maxPoints;
				$markerArray["###VAR_MISSING_POINTS###"] = $maxPoints - $points;
				$markerArray["###VAR_TOTAL_POINTS###"] = $pointsTotal;
				$markerArray["###VAR_TMAX_POINTS###"] = $maxTotal;
				$markerArray["###VAR_TMISSING_POINTS###"] = $maxTotal - $pointsTotal;
				if ($maxTotal>0)
					$percent = intval(round(100 * $pointsTotal / $maxTotal));
				$markerArray["###VAR_PERCENT###"] = $percent;
				$overallMaximum = $markerArray["###VAR_OMAX_POINTS###"];
				if ($overallMaximum) {
					$overallPercent = 100 * $pointsTotal / $overallMaximum;
					$markerArray["###VAR_OVERALL_PERCENT###"] = intval(round($overallPercent));
					//$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;
				}
				
				if ($doUpdate == 0) {
					$overallMaximum = $helperObj->getQuestionsMaxPoints();		// maximum points of all questions
					if ($overallMaximum > 0)
						$overallPercent = 100 * $markerArray["###VAR_TOTAL_POINTS###"] / $overallMaximum;
					$markerArray["###VAR_OVERALL_PERCENT###"] = intval(round($overallPercent));
					$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;

					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_POINTS###");
				} else {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_POINTS_TOTAL###");
				}
				$markerArrayP["###REF_QPOINTS###"] = $this->cObj->substituteMarkerArray($template, $markerArray);  // instead $content
			}
			
			if ( $this->conf['startCategory'] && $nextCat ) {	//  && $this->conf['pageQuestions']==1
				$this->conf['startCategory'] = $nextCat;	// kategorie der naechsten frage
			}
			
			if ($points == '')
				$points = 0;
			if ($pointsTotal == '')
				$pointsTotal = 0;
				
			if ($doUpdate==0 && ($points>0 || !$this->conf['isPoll'])) {
				//Jokers
				$joker1 = intval($quizData["joker1"]);
				$joker2 = intval($quizData["joker2"]);
				$joker3 = intval($quizData["joker3"]);
				
				// Insert new results into database
				$timestamp = time();
				$firsttime = intval($quizData["time"]);
				$insert = array('pid' => $resPID,
								'tstamp' => $timestamp,
								'crdate' => $timestamp,
								'name' => $quiz_taker_name,
								'email' => $quiz_taker_email,
								'homepage' => $quiz_taker_homepage,
								'ip' => $quiz_taker_ip_address,
								'p_or_a' => $points,
								'p_max' => $maxPoints,
								'percent' => $percent,
								'o_max' => $overallMaximum,
								'o_percent' => $overallPercent,
								'qids' => $answered,
								'cids' => $correctAnsw,
								'fids' => $falseAnsw,
								'sids' => $skipped,
								'joker1' => $joker1,
								'joker2' => $joker2,
								'joker3' => $joker3,
								'firsttime' => $firsttime,
								'lasttime' => $timestamp,
								'lastcat' => $lastCat,
								'nextcat' => $nextCat,
								'fe_uid' => $GLOBALS['TSFE']->fe_user->user['uid'],
								'sys_language_uid' => $this->lang);
				$success = $GLOBALS['TYPO3_DB']->exec_INSERTquery($tableAnswers, $insert);
				if($success){
					$quizData["qtuid"] = $GLOBALS['TYPO3_DB']->sql_insert_id();
					if ( $this->conf['useCookiesInDays']>0 ) {	// save quiz takers UID as cookie?
						if ($this->conf['cookieMode']==1)
							$cookieName = "myquizpoll".$resPID.'_'.$this->lang;
						else if ($this->conf['cookieMode']==2 && $GLOBALS['TSFE']->fe_user->user['uid'])
							$cookieName = "myquizpoll".$resPID.'_'.$GLOBALS['TSFE']->fe_user->user['uid'];
						else
							$cookieName = "myquizpoll".$resPID;
						//if (!($this->conf['isPoll'] && $_COOKIE[$cookieName])) {	// bein Umfragen Cookie nicht ueberschreiben...
							$helperObj->addDebug('Storing Cookie: '.$cookieName.'='.$quizData["qtuid"]);
							setcookie($cookieName, $quizData["qtuid"], time()+(3600*24*intval($this->conf['useCookiesInDays'])));  /* cookie for x days */
						//}
					}
					$helperObj->setFirstTime($quizData["qtuid"], $firsttime);
				} else {
					$content.="<p>MySQL Insert-Error :-(</p>";
				}
			} else if ($doUpdate==1) {
				// update current user entry
				$uid=intval($quizData["qtuid"]);
				$timestamp = time();
				$update = array('tstamp' => $timestamp,
								'name' => $quiz_taker_name,
								'email' => $quiz_taker_email,
								'homepage' => $quiz_taker_homepage,
								'p_or_a' => $pointsTotal,
								'p_max' => $maxTotal,
								'percent' => $percent,
								'o_percent' => $overallPercent,
								'qids' => $answered,
								'cids' => $correctAnsw,
								'fids' => $falseAnsw,
								'sids' => $skipped,
								'lastcat' => $lastCat,
								'nextcat' => $nextCat,
								'lasttime' => $timestamp);
				$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($tableAnswers, 'uid='.$uid.' AND sys_language_uid='.$this->lang, $update);
				if(!$success){
					$content.="<p>MySQL Update-Error :-(</p>";
				}
			} else if ($doUpdate==3) {
				// update current skipped entry (only skipped questions?!?!)
				$uid=intval($quizData["qtuid"]);
				$timestamp = time();
				$update = array('tstamp' => $timestamp,
								'sids' => $skipped,
								'lasttime' => $timestamp);
				$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($tableAnswers, 'uid='.$uid.' AND sys_language_uid='.$this->lang, $update);
				if(!$success){
					$content.="<p>MySQL Update-Error :-(</p>";
				}
			}
			
			$markerArray["###QTUID###"] = $quizData["qtuid"];
			
			if ($this->conf['advancedStatistics'] && $doUpdate<2) {
				// write advanced Statistics to database
				$uid=intval($quizData["qtuid"]);
				$timestamp = time();
				if (is_array($statisticsArray)) {
					foreach ($statisticsArray as $type => $element) {
						$insert = array('pid' => $resPID,
										'tstamp' => $timestamp,
										'crdate' => $timestamp,
										'user_id' => $uid,
										'question_id' => $type,
										'textinput' => $element['text'],
										'points' => $element['points'],
										'sys_language_uid' => $this->lang);
						//$array2=array();
						for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
							$insert['checked'.$answerNumber] = $element['a'.$answerNumber];
						}
						//$insert = array_merge($array1, $array2);
						$GLOBALS['TYPO3_DB']->exec_INSERTquery($tableRelation, $insert);
					}
				}
			}
			
			if (!$this->conf['pageQuestions'] && !$this->conf['isPoll']) {
				$finalPage = true;
			}
			$answerPage = true;
		}
		
		
		if( $this->conf['finishedMinPercent'] && $this->conf['pageQuestions']>0 && $markerArray["###VAR_TOTAL_POINTS###"]!=='' &&
		  (!$this->conf['showAnswersSeparate'] || !$quizData["cmd"]) && $no_rights==0 ) {  /* ***************************************************** */
			/*
			 * Display positive cancel page: quiz taker has reached finishedMinPercent percent???
			 */

			if ($markerArray["###VAR_OMAX_POINTS###"])
				$myPercent = 100 * $markerArray["###VAR_TOTAL_POINTS###"] / $markerArray["###VAR_OMAX_POINTS###"];
			else
				$myPercent = 0;
			$uidP = 0;
			$finishedMinPercent = $this->conf['finishedMinPercent'];
			if (strpos($finishedMinPercent, ':') !== false) {
				list($finishedMinPercent, $uidP) = split(":", $finishedMinPercent);
			}
			if (intval($finishedMinPercent) <= $myPercent) {		// do we have enough points???
				if ($uidP)		// redirect to a URL with that UID?
					$this->redirectUrl($uidP, array());
				$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
				$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
				$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
				$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
				//$markerArray["###VAR_OVERALL_PERCENT###"] = intval($myPercent);
				//$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;
				
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_FINISHEDMINPERCENT###");
				if ($template == '')	// if it is not in the template
					$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUIZ_FINISHEDMINPERCENT###");
				$content .= $this->cObj->substituteMarkerArray($template, $markerArray);			// sonderfall !!!!!!!!!
				
				$answerPage = false;
				if ( $this->conf['showHighscore'] ) {
					$quizData["cmd"] = 'score';		// show highscore
				} else {
					$quizData["cmd"] = 'exit';		// display no more questions
				}
			}
		}
		
		if( $this->conf['cancelWhenWrong'] && $this->conf['pageQuestions']>0 && ($markerArray["###VAR_TOTAL_POINTS###"]!=='') &&
		  (!$this->conf['showAnswersSeparate'] || !$quizData["cmd"]) && $no_rights==0 ) {  /* ***************************************************** */
			/*
			 * Display negative cancel page: quiz taker has given a wrong answer???
			 */
			if ($markerArray["###VAR_TOTAL_POINTS###"] < $markerArray["###VAR_TMAX_POINTS###"]) {
				$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
				$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
				$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
				$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
				$markerArray["###QUIZ_END###"] = $this->pi_getLL('quiz_end','quiz_end');
				$markerArray["###RESTART_QUIZ###"] = $this->pi_linkToPage($this->pi_getLL('restart_quiz','restart_quiz'), $startPID, $target = '', array());
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_END###");
				if ($template == '')	// if it is not in the template
					$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUIZ_END###");
				$content .= $this->cObj->substituteMarkerArray($template, $markerArray);			// sonderfall !!!
				
				$answerPage = false;		// show no answers
				
				if ( $this->conf['finalWhenCancel'] ) {
					$noQuestions = true;
				} else {
					if ( $this->conf['showHighscore'] ) {
						$quizData["cmd"] = 'score';		// show highscore
					} else {
						$quizData["cmd"] = 'exit';		// display no more questions
					}
					$no_rights = 1;					// cancel all				
				}
			}
		}
		
		// Pre-fill quiz taker name and email if FE user logged in
		if ($GLOBALS['TSFE']->loginUser) {
			if (!$quizData["name"]) { $quizData["name"] = $GLOBALS['TSFE']->fe_user->user['name']; }
			if (!$quizData["email"]) { $quizData["email"] = $GLOBALS['TSFE']->fe_user->user['email']; }
			if (!$quizData["homepage"]) { $quizData["homepage"] = $GLOBALS['TSFE']->fe_user->user['www']; }
		}
		if ($quizData["name"]) {
			$markerArray["###DEFAULT_NAME###"] = $quizData["name"];
		} else {
			$markerArray["###DEFAULT_NAME###"] = $this->pi_getLL('no_name','no_name');
		}
		if ($quizData["email"]) {
			$markerArray["###DEFAULT_EMAIL###"] = $quizData["email"];
		} else {
			$markerArray["###DEFAULT_EMAIL###"] = $this->pi_getLL('no_email','no_email');
		}
		if ($quizData["homepage"]) {
			$markerArray["###DEFAULT_HOMEPAGE###"] = $quizData["homepage"];
		} else {
			$markerArray["###DEFAULT_HOMEPAGE###"] = $this->pi_getLL('no_homepage','no_homepage');
		}
		
		// UID loeschen bei Umfragen
		if ($this->conf['isPoll']) {
			$quizData["qtuid"] = '';
		}
		
		
		if( $quizData["cmd"] == '' && $no_rights==0 ) {           /* ***************************************************** */
			/*
			 * Display initial page: questions and quiz taker name fields
			 */
			
			/*$helperObj->setPageTime($quizData["qtuid"], $markerArrayP["###VAR_NOW###"]);
			if ($quizData["qtuid"] && $this->settings['pageTimeSeconds'] && $this->settings['userSession']) {
				//$GLOBALS['TSFE']->fe_user->setKey('ses','pagetime'.$uid, $time);
				$globalJS .= 
			}*/
		
			if (!$noQuestions) {
				// Order questions by & and limit to
				$sortBy = 'sorting';
				$limitTo = '';
				$whereCat = '';
				if ( $this->conf['sortBy'] ) {
					switch ($this->conf['sortBy']) {
						case "sorting": $sortBy = "sorting"; break;
						case "uid": $sortBy = "uid"; break;
						case "title": $sortBy = "title"; break;
						default: $sortBy = "sorting"; break;
					}
				}
				// Limit questions?
				if ( $this->conf['pageQuestions']>0 && $this->conf['sortBy']!='random' ) {
					$limitTo = $this->conf['pageQuestions'];
				}
				// category
				if ( $this->conf['startCategory'] ) {	//  && $this->conf['pageQuestions']==1
					$whereCat = " AND category='".intval($this->conf['startCategory'])."'";
				}
				
				// Get questions from the database    
				$questionsArray = array();
				$questionNumber = 0;
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
						$tableQuestions,
						'pid='.$thePID.$whereCat.$whereAnswered.$whereSkipped.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
						'',
						$sortBy,
						$limitTo);
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if (!$rows) {		// now ignore the skipped questions
					$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
						$tableQuestions,
						'pid='.$thePID.$whereCat.$whereAnswered.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
						'',
						$sortBy,
						$limitTo);
					$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				}
				$helperObj->addDebug($rows.' rows selected with: pid='.$thePID.$whereCat.$whereAnswered.' AND sys_language_uid='.$this->lang);
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
						$questionNumber++;
						$questionsArray[$questionNumber] = $row;
					}
				}
				
				$numOfQuestions = $questionNumber;				// real questions
				$maxQuestions = $this->conf['pageQuestions'];	// should be questions
				
				if ($this->conf['isPoll']) {
					$maxQuestions = 1;					// only max. 1 poll-question
				} else if ( !$maxQuestions ) {
					$maxQuestions = $numOfQuestions; 
				} else if( $numOfQuestions < $maxQuestions ) { 
					$maxQuestions = $numOfQuestions; // no. of maximum question = no. of questions in the DB 
				}
			
				if ( ($numOfQuestions > 0) and ($this->conf['sortBy']=='random') ) {		// any questions out there???	Random questions???
					$randomQuestionsArray = array();
					$questionNumber = 0;
					// Not very fast random method
					while( $questionNumber < $maxQuestions ) {
						$random = mt_rand(1,$numOfQuestions);
						$randomQuestionsArray[$questionNumber+1] = $questionsArray[$random];
						$duplicate = 0;
						for($i=1 ; $i < $questionNumber+1; $i++) {
							if( $randomQuestionsArray[$questionNumber+1]['uid'] == $randomQuestionsArray[$i]['uid'] ) {
								$duplicate = 1 ;
							}
						}
						if( !$duplicate ) { $questionNumber++ ; }
					}
					// rearange questions Array
					for( $questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++ ) {
						$questionsArray[$questionNumber] = $randomQuestionsArray[$questionNumber];
					}
				}
				
				if ($this->conf['finishAfterQuestions']) {		// finish after X questions?
					$numOfQuestions = intval($this->conf['finishAfterQuestions']) - $helperObj->getQuestionNo($whereAnswered);
					if( $numOfQuestions < $maxQuestions ) { 
						$maxQuestions = $numOfQuestions; // no. of maximum question = no. of questions in the DB 
					}
				}
			} else {
				$numOfQuestions = 0;
			}
			
			if ( $numOfQuestions > 0 ) {		// any questions out there???
				
				// Start des Output
//				$content .= "<form action=\"".$this->pi_getPageLink($GLOBALS['TSFE']->id)."\" method=\"post\" name=\"myquiz\">\n";  // old, deprecated since 0.1.8
				$lastUID = 0;		// remember the last question ID
				$imgTSConfig = array();
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION###");
				$template_image_begin = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_BEGIN###");
				$template_image_end = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_END###");
				$template_answer = $this->cObj->getSubpart($template, "###TEMPLATE_QUESTION_ANSWER###");
				$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");
				
				if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
					$markerArray["###P1###"] = $this->pi_getLL('p1','p1');
					$markerArray["###P2###"] = $this->pi_getLL('p2','p2');
				} else {
					$markerArray["###P1###"] = '';
					$markerArray["###P2###"] = '';
				}
				$markerArray["###VAR_QUESTIONS###"] = $helperObj->getQuestionsNo();
				$markerArray["###VAR_QUESTION###"] = $helperObj->getQuestionNo($whereAnswered);
				
				// Questions and answers
				for ($questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++) {
					$row = $questionsArray[$questionNumber];
					
					$answerPointsBool = false;		// gibt es punkte bei einzelnen antworten?
					$markerArray["###VAR_QUESTION###"]++;
					if ($row['image']) {
						$imgTSConfig['file'] = 'uploads/tx_myquizpoll/'.$row['image']; //The image field name
						$imgTSConfig['altText'] = $row["alt_text"];
						$imgTSConfig['titleText'] = $row["alt_text"];
						if (is_array($this->conf['images.'])) {
							$imgTSConfig['file.']['maxW'] = $this->conf['images.']['maxW'];
							$imgTSConfig['file.']['maxH'] = $this->conf['images.']['maxH'];
						}
						//$this->conf["image."]["file"] = 'uploads/tx_myquizpoll/'.($row['image']); //The image field name
						$markerArray["###VAR_QUESTION_IMAGE###"] = $this->cObj->IMAGE($imgTSConfig);	// statt $this->conf["image."]
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = $this->cObj->substituteMarkerArray($template_image_begin, $markerArray);
						$markerArray["###REF_QUESTION_IMAGE_END###"] = $template_image_end;
					} else {
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = '';
						$markerArray["###REF_QUESTION_IMAGE_END###"] = '';
					}
					$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
					$markerArray["###VAR_QUESTION_NAME###"] = $this->formatStr($this->local_cObj->stdWrap($row['name'],$this->conf["general_stdWrap."])); //$this->pi_RTEcssText($row['name']);
					if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] && $row['qtype']<5) {
						$markerArray["###VAR_QUESTION_POINTS###"] = 0;
						if ($markerArray["###VAR_TOTAL_POINTS###"])
							$markerArray["###VAR_NEXT_POINTS###"] = $markerArray["###VAR_TOTAL_POINTS###"];
						else
							$markerArray["###VAR_NEXT_POINTS###"] = 0;
						for ($currentValue=1; $currentValue <= $this->answerChoiceMax; $currentValue++) {
							if (intval($row['points'.$currentValue])>0 ) {
								$answerPointsBool = true;
								break;
							}
						}
						if ($answerPointsBool)
							$markerArray["###VAR_ANSWER_POINTS###"] = $this->pi_getLL('different_number_of','different_number_of');
						else {
							if (($row['qtype'] == 0 || $row['qtype'] == 4) && $this->conf['noNegativePoints']<3)
								$markerArray["###VAR_ANSWER_POINTS###"] = $this->pi_getLL('each','each').' '.$row['points'];
							else
								$markerArray["###VAR_ANSWER_POINTS###"] = $row['points'];
						}
					} else {
						$markerArray["###VAR_ANSWER_POINTS###"] = '';
						$markerArray["###VAR_QUESTION_POINTS###"] = '';
						$markerArray["###VAR_NEXT_POINTS###"] = '';
					}
					$markerArray["###REF_QUESTION_ANSWER###"] = '';
					if ($row['qtype'] == 2) {
						$markerArray["###VAR_QUESTION_ANSWER###"] = '<select name="tx_myquizpoll_pi1[answer'.$questionNumber.']" ###MY_SELECT###>'."\n"; //  class="'.$this->prefixId.'-answer"
					} 
					
					if (is_array($this->conf['myVars.']['questions.'])) {
						foreach ($this->conf['myVars.']['questions.'] as $key => $value) {
							$myQArray = split(',', $value);
							$myKey = ($questionNumber-1)%count($myQArray);
							$markerArray["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
						}
					}
					if (!$markerArray["###MY_SELECT###"])			// we need default values...
						$markerArray["###MY_SELECT###"] = '';
					
					// Jokers
					if ($this->conf['useJokers'] && $this->conf['pageQuestions']==1) {
						$temp_uid = $quizData["qtuid"];
						$markerArrayJ["###JAVASCRIPT###"] = '';
						if (!$temp_uid) $temp_uid=0;
						$markerArrayJ["###JOKER_50###"] = $this->pi_getLL('joker_50','joker_50');
						$markerArrayJ["###JOKER_AUDIENCE###"] = $this->pi_getLL('joker_audience','joker_audience');
						$markerArrayJ["###JOKER_PHONE###"] = $this->pi_getLL('joker_phone','joker_phone');
						if (is_array($this->conf['jokers.']))
							$unlimited = $this->conf['jokers.']['unlimited'];
						else
							$unlimited = 0;
						if ($joker1 && !$unlimited) {
							$markerArrayJ["###JOKER_50_LINK###"] = '';
							$markerArrayJ["###JAVASCRIPT###"] .= "document.getElementById('".$this->prefixId."-joker_50').style.display = 'none';\n";
						} else
							$markerArrayJ["###JOKER_50_LINK###"] = $this->prefixId.'getAjaxData('.$row['uid'].','.$temp_uid.',1,\'joker_50\');';
						if ($joker2 && !$unlimited) {
							$markerArrayJ["###JOKER_AUDIENCE_LINK###"] = '';
							$markerArrayJ["###JAVASCRIPT###"] .= "document.getElementById('".$this->prefixId."-joker_audience').style.display = 'none';\n";
						} else
							$markerArrayJ["###JOKER_AUDIENCE_LINK###"] = $this->prefixId.'getAjaxData('.$row['uid'].','.$temp_uid.',2,\'joker_audience\');';
						if ($joker3 && !$unlimited) {
							$markerArrayJ["###JOKER_PHONE_LINK###"] = '';
							$markerArrayJ["###JAVASCRIPT###"] .= "document.getElementById('".$this->prefixId."-joker_phone').style.display = 'none';\n";
						} else
							$markerArrayJ["###JOKER_PHONE_LINK###"] = $this->prefixId.'getAjaxData('.$row['uid'].','.$temp_uid.',3,\'joker_phone\');';
						
						$template_jokers = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_JOKERS###");
						$markerArrayP["###REF_JOKERS###"] = $this->cObj->substituteMarkerArray($template_jokers, $markerArrayJ);
					}
					
					$thisCat = $row['category'];
					if ($catArray[$thisCat]) $markerArray["###VAR_CATEGORY###"] = $catArray[$thisCat];
					
					// Display answers
					$answers = 0;
					for( $currentValue=1; $currentValue < $this->answerChoiceMax+1; $currentValue++) {
						if( $row['answer'.$currentValue] || $row['answer'.$currentValue]==='0' || ($row['qtype']==5 && $currentValue==1) ) {
							$answers++;
							if (is_array($this->conf['myVars.']['answers.']) && ($row['qtype'] != 2 || $currentValue == 1)) {
								foreach($this->conf['myVars.']['answers.'] as $key => $value) {
									$myAArray = split(',', $value);
									$myKey = ($currentValue-1)%count($myAArray);
									$markerArray["###MY_".strtoupper($key)."###"] = $myAArray[$myKey];
								}
							}
							if (!$markerArray["###MY_OPTION###"]) $markerArray["###MY_OPTION###"] = '';
							if (!$markerArray["###MY_INPUT_RADIO###"]) $markerArray["###MY_INPUT_RADIO###"] = '';
							if (!$markerArray["###MY_INPUT_CHECKBOX###"]) $markerArray["###MY_INPUT_CHECKBOX###"] = '';
							if (!$markerArray["###MY_INPUT_TEXT###"]) $markerArray["###MY_INPUT_TEXT###"] = '';
							if (!$markerArray["###MY_INPUT_AREA###"]) $markerArray["###MY_INPUT_AREA###"] = '';
							if (!$markerArray["###MY_INPUT_WRAP###"]) $markerArray["###MY_INPUT_WRAP###"] = '';
								
							if ($row['qtype']<3 || $row['qtype']==4) {
								$answer_choice = $this->formatStr($this->local_cObj->stdWrap($row['answer'.$currentValue],$this->conf["general_stdWrap."]));	// Problem: <tt> geht hier verloren!
								if (!(strpos($markerArray["###MY_INPUT_WRAP###"],'|') === false))
									$answer_choice = str_replace('|',$answer_choice,$markerArray["###MY_INPUT_WRAP###"]);
							}
							
							$input_id = '';
							$input_label1 = '';
							$input_label2 = '';
							
							// Questtion type
							if ($row['qtype'] == 1) {
								if ($markerArray["###MY_INPUT_ID###"]) $input_id = 'id="answer'.$questionNumber.'_'.$currentValue.'"';
								if ($markerArray["###MY_INPUT_LABEL###"]) { $input_label1 = '<label for="answer'.$questionNumber.'_'.$currentValue.'">'; $input_label2 = '</label>'; }
								$answer_content = '<input type="radio" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="'.$currentValue.'" '.$input_id.' ###MY_INPUT_RADIO### /> ';
							} else if ($row['qtype'] == 2) {
								$answer_content = '<option value="'.$currentValue.'" ###MY_OPTION###> ';
							} else if ($row['qtype'] == 3) {
								if ($markerArray["###MY_INPUT_ID###"]) $input_id = 'id="answer'.$questionNumber.'"';
								$answer_content = '<input type="text" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="" '.$input_id.' ###MY_INPUT_TEXT### /> ';
							} else if ($row['qtype'] == 4) {
								$answer_content = $answer_choice;
								if ($markerArray["###MY_INPUT_ID###"]) $input_id = 'id="answer'.$questionNumber.'_'.$currentValue.'_1"';
								if ($markerArray["###MY_INPUT_LABEL###"]) { $input_label1 = '<label for="answer'.$questionNumber.'_'.$currentValue.'_1">'; $input_label2 = '</label>'; }
								$answer_content .= ' <input type="radio" name="tx_myquizpoll_pi1[answer'.$questionNumber.'_'.$currentValue.']" '.$input_id.' value="'.$currentValue.'" ###MY_INPUT_RADIO### /> '.$input_label1.$this->pi_getLL('yes','yes').$input_label2;
								if ($markerArray["###MY_INPUT_ID###"]) $input_id = 'id="answer'.$questionNumber.'_'.$currentValue.'_0"';
								if ($markerArray["###MY_INPUT_LABEL###"]) { $input_label1 = '<label for="answer'.$questionNumber.'_'.$currentValue.'_0">'; $input_label2 = '</label>'; }
								$answer_content .= ' <input type="radio" name="tx_myquizpoll_pi1[answer'.$questionNumber.'_'.$currentValue.']" '.$input_id.' value="0" ###MY_INPUT_RADIO### /> '.$input_label1.$this->pi_getLL('no','no').$input_label2;
							} else if ($row['qtype'] == 5) {
								if ($markerArray["###MY_INPUT_ID###"]) $input_id = 'id="answer'.$questionNumber.'"';
								$answer_content = '<textarea name="tx_myquizpoll_pi1[answer'.$questionNumber.']" '.$input_id.' ###MY_INPUT_AREA###></textarea> ';
							} else {
								if ($markerArray["###MY_INPUT_ID###"]) $input_id = 'id="answer'.$questionNumber.'_'.$currentValue.'"';
								if ($markerArray["###MY_INPUT_LABEL###"]) { $input_label1 = '<label for="answer'.$questionNumber.'_'.$currentValue.'">'; $input_label2 = '</label>'; }
								$answer_content = '<input type="checkbox" name="tx_myquizpoll_pi1[answer'.$questionNumber.'_'.$currentValue.']" value="'.$currentValue.'" '.$input_id.' ###MY_INPUT_CHECKBOX### /> ';
							}
							
							if (!$this->conf['dontShowPoints'] && !$this->conf['isPoll'] && $row['qtype']<5) {
								$tmpPoints = 0;
								if ($this->conf['noNegativePoints']<3 && $answerPointsBool)	// das ganze Verhalten am 21.01.10 geaendert...
									$tmpPoints = intval($row['points'.$currentValue]);
								if ($tmpPoints>0)
									$row['correct'.$currentValue] = true;		// ACHTUNG: falls Punkte zu einer Antwort gesetzt sind, dann wird die Antwort als RICHTIG bewertet!
								else
									$tmpPoints = intval($row['points']);
								if ($row['correct'.$currentValue] || $row['qtype']==3) {
									if (($row['qtype'] == 0 || $row['qtype'] == 4) && $this->conf['noNegativePoints']<3) {
										$markerArray["###VAR_QUESTION_POINTS###"]+=$tmpPoints;	// points for each answer
									} else if ($tmpPoints > $markerArray["###VAR_QUESTION_POINTS###"]) {
										$markerArray["###VAR_QUESTION_POINTS###"]=$tmpPoints;	// points for each answer
									}
								}
							}
							
							if ($row['qtype'] < 3) $answer_content .= $input_label1.$answer_choice.$input_label2;
							if ($row['qtype'] == 2) {
								$answer_content .= "</option>\n";
								$markerArray["###VAR_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($answer_content, $markerArray);
							} else {
								$markerArray['###VAR_QUESTION_ANSWER###'] = $this->cObj->substituteMarkerArray($answer_content, $markerArray);
								$markerArray["###REF_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
							}
						}
					}
					
					if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] && $row['qtype']<5 )
						$markerArray["###VAR_NEXT_POINTS###"]+=$markerArray["###VAR_QUESTION_POINTS###"];
					
					if ($this->conf['allowSkipping']) {		// skip answers
						// Questtion type
						if ($row['qtype'] == 1) {
							$answer_content = '<input type="radio" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="-1" /> '.$this->pi_getLL('skip','skip');
						} else if ($row['qtype'] == 2) {
							$answer_content = '<option value="-1"> '.$this->pi_getLL('skip','skip').'</option>';
						} else if ($row['qtype'] < 6) {
							$answer_content = '<input type="checkbox" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="-1" /> '.$this->pi_getLL('skip','skip');
						}
						if ($row['qtype'] == 2) {
							$markerArray['###VAR_QUESTION_ANSWER###'] .= $answer_content;
						} else {
							$markerArray['###VAR_QUESTION_ANSWER###'] = $answer_content;
							$markerArray["###REF_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
						}
					}
					
					if ($row['qtype'] == 2) {
						$markerArray["###VAR_QUESTION_ANSWER###"] .= "</select>\n";
						$markerArray["###REF_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
					}
					if ( ($this->conf['userData.']['askAtQuestion'] || $questionNumber<$maxQuestions) && !$this->conf['isPoll'] ) {	// statt !$this->conf['dontShowUserData']
						$markerArray["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArray);
					} else {
						$markerArray["###REF_DELIMITER###"] = '';
					}
					
					if ($this->conf['enforceSelection']) {	// 25.1.10: antwort erzwingen?
						$helperObj->addEnforceJsc($questionNumber,$answers,$row['qtype']);
					}
					
					//$this->subpart = $template;
					$template2 = $this->cObj->substituteSubpart($template, '###TEMPLATE_QUESTION_ANSWER###', $markerArray["###REF_QUESTION_ANSWER###"], 0);
					$markerArrayP["###REF_QUESTIONS###"] .= $this->cObj->substituteMarkerArray($template2, $markerArray);	// statt $content .= since 0.1.8
					$markerArrayP["###REF_QUESTIONS###"] .= '<input type="hidden" name="tx_myquizpoll_pi1[uid'.$questionNumber.']" value="'.$row['uid'].'" class="input_hidden" />';
					if ($this->conf['isPoll']) {	// link to the result page    && $this->conf['showPollResultLink']
						$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "list", "tx_myquizpoll_pi1[qid]" => $row['uid'], "no_cache" => "1");
						$markerArray["###POLLRESULT_URL###"] = $this->pi_linkToPage($this->pi_getLL('poll_url','poll_url'), $listPID, $target = '', $urlParameters);
					}
					$lastUID=$row['uid'];
				}
				
				// 14.10.2009: hier wurden die Default-Namen und so gesetzt, jetzt hoeher...
				$markerArrayP["###REF_SUBMIT_FIELDS###"] = '';
				$markerArrayP["###HIDDENFIELDS###"] = '';
				$helperObj->addDebug('last question: '.$lastUID);
				
				// User-Data Template
				if ( $this->conf['userData.']['askAtQuestion'] && !$this->conf['isPoll'] ) {	// statt !$this->conf['dontShowUserData']
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_TO_SUBMIT###");
					if (is_object($this->freeCap) && $this->conf['enableCaptcha']) {
						$markerArray = array_merge($markerArray, $this->freeCap->makeCaptcha());
					} else {
						$subpartArray['###CAPTCHA_INSERT###'] = '';
					}
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray);
				} else if (!($answeredQuestions==$lastUID && $this->conf["isPoll"])) {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_SUBMIT###");
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArray($template, $markerArray); // new in 0.1.8
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="name" value="'.$markerArray["###DEFAULT_NAME###"].'" /> '; // statt $template .= since 0.1.8
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[name]" value="'.$quizData["name"].'" />';  // wozu die Zeile davor???
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[email]" value="'.$quizData["email"].'" />';
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[homepage]" value="'.$quizData["homepage"].'" />';
				} else {
					$markerArray["###NO_SUBMIT###"] = $this->pi_getLL('no_submit','no_submit');
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NO_SUBMIT###");
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArray($template, $markerArray); // new in 0.1.8
				}
				if (!$this->conf['isPoll']) {		// when is Poll, do not update result-table
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[qtuid]" value="'.$quizData["qtuid"].'" />';  // statt $template .= since 0.1.8
				}
				//$template .= "<input type=\"hidden\" name=\"###PREFIX###[max]\" value=\"$maxPoints\">\n";  // old, deprecated since 0.1.7
				if (!$quizData["qtuid"])
					$markerArrayP["###HIDDENFIELDS###"] .= '
  <input type="hidden" name="'.$this->prefixId.'[time]" value="'.time().'" />';
				$markerArrayP["###HIDDENFIELDS###"] .= '
  <input type="hidden" name="no_cache" value="1" />
  <input type="hidden" name="'.$this->prefixId.'[cmd]" value="submit" />';
				
				if ($this->conf['useJokers'] && $this->conf['pageQuestions']==1) {
					$markerArrayP["###HIDDENFIELDS###"] .= '
  <input type="hidden" name="'.$this->prefixId.'[joker1]" value="0" />
  <input type="hidden" name="'.$this->prefixId.'[joker2]" value="0" />
  <input type="hidden" name="'.$this->prefixId.'[joker3]" value="0" />';
				}
				
				$markerArrayP["###SUBMIT_JSC###"] = $helperObj->getSubmitJsc();
				
				$questionPage = true;	
			
			} else {
			
				// final page: no more questions left, if pageQuestions > 0
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NO_MORE###");
				$markerArray["###NO_MORE###"] = $this->pi_getLL('no_more','no_more');
				$markerArray['###YOUR_EVALUATION###'] = $this->pi_getLL('your_evaluation','your_evaluation');
				$markerArray['###REACHED1###'] = $this->pi_getLL('reached1','reached1');
				$markerArray['###REACHED2###'] = $this->pi_getLL('reached2','reached2');
				$markerArray['###POINTS###'] = $this->pi_getLL('points','points');
			/*	if ($this->conf['startPID'])		// wir sind nicht auf der Startseite, also parent holen...
					$restart_id = $this->conf['startPID']; // $GLOBALS['TSFE']->page['pid'];
				else 
					$restart_id = $GLOBALS['TSFE']->id;	*/
				$markerArray["###RESTART_QUIZ###"] = $this->pi_linkToPage($this->pi_getLL('restart_quiz','restart_quiz'), $startPID, $target = '', array());
				$questions = '';
				
				if ($this->conf['showAllCorrectAnswers'] && !$this->conf['isPoll']) {		// show all answers...
					/*if ($this->conf['finishAfterQuestions'])
						$fragen = intval($this->conf['finishAfterQuestions']);
					else
						$fragen = $helperObj->getQuestionsNo();*/
					$questions = $this->showAllAnswers( $quizData, $thePID,$resPID, $tableQuestions, $tableAnswers, $tableRelation, 0 ); // 24.01.10: 0 statt $fragen
				}
				
				$subpart = $template;
				$template = $this->cObj->substituteSubpart($subpart, '###QUIZ_ANSWERS###', $questions);
				$markerArrayP["###REF_NO_MORE###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
				$markerArrayP["###RESTART_QUIZ###"] = $markerArray["###RESTART_QUIZ###"];
				
				if ( $this->conf['showHighscore'] ) {
					$quizData["cmd"] = 'score';
				}
				$finalPage = true;
			
			}
			
		} else if ($this->conf['showAnswersSeparate'] && $quizData["cmd"]=='submit' && !$this->conf['isPoll'] && $no_rights==0) { /* ***************************************************** */
			/*
			 * Display only a next button
			 */
			 
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NEXT###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_NEXT###");
			$markerArrayP["###REF_NEXT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
		}
		
		
		
		
		/** Redirect to the final page? **/
		if ($finalPage && $quizData["cmd"] != 'exit' && $this->conf['finalPID'] && ($finalPID != intval($GLOBALS["TSFE"]->id))) {
			$this->redirectUrl($finalPID, array($this->prefixId . '[qtuid]' => $quizData["qtuid"], $this->prefixId . '[cmd]' => 'next'));
			break;	// unnoetig...
		}
		
		/** Poll result? **/
		if ($answerPage && $this->conf['isPoll'] && !$this->conf['dontShowPollResult'] ) {
			$quizData["cmd"] = 'list';
		}
		
		
		// Make a page-layout
		if ( $quizData["cmd"] == 'allanswers' && !$this->conf['isPoll'] ) {    /* ***************************************************** */		
			/*
			 * Display all questions and correct answers
			 */
			$content .= $this->showAllAnswers( $quizData, $thePID,$resPID, $tableQuestions, $tableAnswers, $tableRelation, 0 ); // 24.01.10: 0 statt $helperObj->getQuestionsNo()
		}
		
		
		if ( $quizData["cmd"] == 'score' && !$this->conf['isPoll'] ) {         /* ***************************************************** */
			/*
			 * Display highscore page: top 10 table
			 */
			if ($quizData["setUserData"] && $quizData["qtuid"] && $quizData["name"]) {	// ggf. erst Benutzerdaten in der DB setzen...
				$uid = intval($quizData["qtuid"]);
				$firsttime = $helperObj->getFirstTime($uid);
				if ($firsttime == intval($quizData["setUserData"])) {		// Security test bestanden?
					// update current user entry
					$timestamp = time();
					// Avoid bad characters in database request
					$quiz_taker_name = $GLOBALS['TYPO3_DB']->quoteStr($quizData["name"], $tableAnswers); //addslashes($quizData["name"]);
					$quiz_taker_email  = $GLOBALS['TYPO3_DB']->quoteStr($quizData["email"], $tableAnswers); //addslashes($quizData["email"]);
					$quiz_taker_homepage = $GLOBALS['TYPO3_DB']->quoteStr($quizData["homepage"], $tableAnswers); //addslashes($quizData["homepage"]);
					$update = array('tstamp' => $timestamp,
									'name' => $quiz_taker_name,
									'email' => $quiz_taker_email,
									'homepage' => $quiz_taker_homepage);
					$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($tableAnswers, 'uid='.$uid.' AND sys_language_uid='.$this->lang, $update);
					if(!$success){
						$content.="<p>MySQL Update-Error :-(</p>";
					}
				}
				if (($this->conf['email.']['send_admin']==2) || ($this->conf['email.']['send_user']==2))
					$sendMail = true;
			}
			if ($finalPage)
				$markerArrayP["###REF_HIGHSCORE###"] = $this->showHighscoreList($quizData, $resPID, $tableAnswers);
			else
				$content .= $this->showHighscoreList($quizData, $resPID, $tableAnswers);
		
		} else if ( $quizData["cmd"] == 'list' && $this->conf['isPoll'] ) {    /* ***************************************************** */
			/*
			 * Display poll result
			 */
			if ($answerPage)
				$markerArrayP["###REF_POLLRESULT###"] = $this->showPollResult($answered, $quizData, $thePID,$resPID, $tableQuestions, $tableAnswers);
			else
				$content .= $this->showPollResult($answered, $quizData, $thePID,$resPID, $tableQuestions, $tableAnswers);
			$helperObj->addDebug('Poll result: searching questions in '.$thePID.' and results in '.$resPID);
		} 
		
		
		if ( !$this->conf['dontShowHighscoreLink'] && !$this->conf['isPoll'] && $quizData["cmd"]!='score' ) {	// show highscore link?
  			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_URL###");
			//if ($questionPage || $answerPage || $finalPage)
				$markerArrayP["###REF_HIGHSCORE_URL###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			//else
			//	$content .= $this->cObj->substituteMarkerArray($template, $markerArray);
  		}
		
		if ( $this->conf['isPoll'] && $quizData["cmd"]!='list' ) {	// show poll result link? && $this->conf['showPollResultLink']
  			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLLRESULT_URL###");
  			//if ($questionPage || $answerPage)
				$markerArrayP["###REF_POLLRESULT_URL###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			//else
			//	$content .= $this->cObj->substituteMarkerArray($template, $markerArray);
  		}

		
		/** Layout for the start page **/
		if ($startPage) {			
			$markerArrayP["###REF_PAGE_LIMIT###"] = '';
			$markerArrayP["###REF_QUIZ_LIMIT###"] = '';
			$markerArrayP["###HIDDENFIELDS###"] = '<input type="hidden" name="'.$this->prefixId.'[fromStart]" value="1" />';
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_TO_SUBMIT###");
			if (is_object($this->freeCap) && $this->conf['enableCaptcha']) {
				$markerArray = array_merge($markerArray, $this->freeCap->makeCaptcha());
			} else {
				$subpartArray['###CAPTCHA_INSERT###'] = '';
			}
			$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray);
				
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_PAGE###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUESTION_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}
		
		
		/** Layout for a result page **/
		if ($answerPage && $quizData["cmd"] != 'exit') {
			if ( $this->conf['quizTimeMinutes'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_TIME_LIMIT###");
				if (!$quizData["qtuid"]) {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60;
					$markerArray["###VAR_MIN###"] = $this->conf['quizTimeMinutes'];
				} else {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60 - $elapseTime;
					$markerArray["###VAR_MIN###"] = round($markerArray["###VAR_SECS###"]/60);				
				}
				$markerArrayP["###REF_QUIZ_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			} else {
				$markerArrayP["###REF_QUIZ_LIMIT###"] = '';
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_PAGE###");
			if ($template == '')	// if it is not in the (old custom) template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_RESULT_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
			
			if ($this->conf['isPoll'] && $this->conf['email.']['send_admin'])
				$sendMail = true;
		}

		
		/** Layout for a questions page **/
		if ($questionPage && $quizData["cmd"] != 'exit') {
			if ( $this->conf['pageTimeSeconds'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_PAGE_TIME_LIMIT###");
				$markerArray["###VAR_SECS###"] = $this->conf['pageTimeSeconds'];
				$markerArrayP["###REF_PAGE_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			} else {
				$markerArrayP["###REF_PAGE_LIMIT###"] = '';
			}
			
			if ( $this->conf['quizTimeMinutes'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_TIME_LIMIT###");
				if (!$quizData["qtuid"]) {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60;
					$markerArray["###VAR_MIN###"] = $this->conf['quizTimeMinutes'];
				} else {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60 - $elapseTime;
					$markerArray["###VAR_MIN###"] = round($markerArray["###VAR_SECS###"]/60);				
				}
				$markerArrayP["###REF_QUIZ_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			} else {
				$markerArrayP["###REF_QUIZ_LIMIT###"] = '';
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_PAGE###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUESTION_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}
		
		
		/** Layout for the last/final page **/
		$uidP = 0;		// page UID
		$uidC = 0;		// content UID
		if ($finalPage && $quizData["cmd"] != 'exit') {  // nicht noetig: && !$this->conf['isPoll']) {
		
			$helperObj->addDebug('Entering final page.');
			if (($this->conf['showAnalysis'] || $this->conf['showEvaluation']) && !$this->conf['dontShowPoints'] && $markerArray["###VAR_TMAX_POINTS###"]) {	// Analysis depends on points
				$helperObj->addDebug('Displaying Analysis: '.$this->conf['showAnalysis'].' or Evaluation: '.$this->conf['showEvaluation']);
				$points = $markerArray["###VAR_TOTAL_POINTS###"];
				$percent = 100 * $points / $markerArray["###VAR_TMAX_POINTS###"];	// genauerer wert...
				$markerArray["###VAR_PERCENT###"] = intval($percent);
				$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
				$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
				if ($this->conf['showAnalysis'])
					$dataArray = split(',', $this->conf['showAnalysis']);
				else
					$dataArray = split(',', $this->conf['showEvaluation']);
				$templateNo = '';
				$p = 0;
				while ($p < count($dataArray)) {
					$templateNo = $dataArray[$p];
					if (strpos($templateNo, ':') !== false) {
						if ($this->conf['showAnalysis'])
							list($templateNo, $uidP) = split(":", $templateNo);
						else
							list($templateNo, $uidC) = split(":", $templateNo);
					}
					if ($this->conf['showAnalysis']) {
						if ($percent <= floatval($templateNo)) {		// wann abbrechen?
						//	if ($uidP) ...	// redirect to a URL with that UID  -> weiter nach unten verschoben (nach email Versendung!!)
							break;
						}
					} else {
						if ($points <= floatval($templateNo)) {		// wann abbrechen?
							break;
						}
					}
					$p++;
				}
				if (!($uidP || $uidC)) {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_ANALYSIS_$templateNo###");
					$markerArrayP["###REF_QUIZ_ANALYSIS###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
				} else if ($uidC) {
					$confC = array('tables' => 'tt_content','source' => $uidC, 'dontCheckPid' => 1);
					$markerArrayP["###REF_QUIZ_ANALYSIS###"] = $this->cObj->RECORDS($confC);
				}
			}
			
			if (!$uidP) {			// no redirect
				$markerArrayP["###FORM_URL###"] = $this->pi_getPageLink($listPID);		// zur endgueltig letzten seite wechseln
				$markerArrayP["###REF_SUBMIT_FIELDS###"] = '';
				$markerArrayP["###HIDDENFIELDS###"] = '';
				if ( $this->conf['userData.']['showAtFinal'] ) {
					// Avoid bad characters in database request
					$quiz_taker_name = $GLOBALS['TYPO3_DB']->quoteStr($quizData["name"], $tableAnswers); //addslashes($quizData["name"]);
					$quiz_taker_email  = $GLOBALS['TYPO3_DB']->quoteStr($quizData["email"], $tableAnswers); //addslashes($quizData["email"]);
					$quiz_taker_homepage = $GLOBALS['TYPO3_DB']->quoteStr($quizData["homepage"], $tableAnswers); //addslashes($quizData["homepage"]);				
					$markerArray["###REAL_NAME###"] = $quiz_taker_name;
					$markerArray["###REAL_EMAIL###"] = $quiz_taker_email;
					$markerArray["###REAL_HOMEPAGE###"] = $quiz_taker_homepage;
					$markerArray["###RESULT_FOR###"] = $this->pi_getLL('result_for','result_for');
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_SUBMITED###"); // Output the user name
					$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
				}
				
				// User-Data Template
				if ( $this->conf['userData.']['askAtFinal'] && $quizData["qtuid"] ) {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_TO_SUBMIT###");
					if (is_object($this->freeCap) && $this->conf['enableCaptcha']) {
						$markerArray = array_merge($markerArray, $this->freeCap->makeCaptcha());
					} else {
						$subpartArray['###CAPTCHA_INSERT###'] = '';
					}
					$firsttime = $helperObj->getFirstTime($quizData["qtuid"]);
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray);
					$markerArrayP["###HIDDENFIELDS###"] = "\n".'  <input type="hidden" name="'.$this->prefixId.'[qtuid]" value="'.$quizData["qtuid"].'" />'."\n";
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[setUserData]" value="'.$firsttime.'" />';
				}
				
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_FINAL_PAGE###");
				if ($template == '')	// if it is not in the template
					$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUIZ_FINAL_PAGE###");
				$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
			}
			
			if (($this->conf['email.']['send_admin']==1) || ($this->conf['email.']['send_user']==1))
				$sendMail = true;
		}
		
		
		/** Send an/two email(s)? **/
		if ($sendMail && !$error) {
			$helperObj->addDebug('Entering "send emails"...');
			$markerArrayP["###EMAIL_TAKEN###"] = $this->pi_getLL('email_taken','email_taken');
			if (!$markerArrayP["###REF_INTRODUCTION###"] && !$this->conf['isPoll']) {
				if (!$markerArray["###RESULT_FOR###"]) {
					$markerArray["###REAL_NAME###"] = $quizData["name"];
					$markerArray["###REAL_EMAIL###"] = $quizData["email"];
					$markerArray["###REAL_HOMEPAGE###"] = $quizData["homepage"];
					$markerArray["###RESULT_FOR###"] = $this->pi_getLL('result_for','result_for');
				}
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_SUBMITED###"); // Output the user name
				$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);			
			}
			
			if ($this->conf['showAllCorrectAnswers'] && !$this->conf['isPoll']) {		// show all answers...
				/*if ($this->conf['finishAfterQuestions'])
					$fragen = intval($this->conf['finishAfterQuestions']);
				else
					$fragen = $helperObj->getQuestionsNo();*/
				$quizData['sendEmailNow'] = true;			// noetig um zu wissen, welches Template genommen werden soll
				$markerArrayP["###REF_EMAIL_ALLANSWERS###"] = $this->showAllAnswers( $quizData, $thePID,$resPID, $tableQuestions, $tableAnswers, $tableRelation, 0 ); // 24.1.10: 0 statt $fragen
			} else {
				$markerArrayP["###REF_EMAIL_ALLANSWERS###"] = '';
			}
			
			if ($this->conf['email.']['send_admin'] && $helperObj->isvalidemail($this->conf['email.']['admin_mail']) && $this->conf['email.']['admin_subject']) {
				$helperObj->addDebug('Sending email to admin...');
				$markerArrayP["###SUBJECT###"] = $this->conf['email.']['admin_subject'];
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_ADMIN_EMAIL###");
				if ($template == '')	// if it is not in the template
					$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_ADMIN_EMAIL###");
				$mailcontent = $this->cObj->substituteMarkerArray($template, $markerArrayP);
				$helperObj->sendEmail($mailcontent,$this->pi_getLL('email_text','email_text'),$this->conf['email.']['admin_mail'],$this->conf['email.']['admin_name'],$this->conf['email.']['admin_subject']);
			}
			if ($this->conf['email.']['send_user'] && $helperObj->isvalidemail($quizData["email"]) && $this->conf['email.']['user_subject']) {
				$helperObj->addDebug('Sending email to user...');
				$markerArrayP["###SUBJECT###"] = $this->conf['email.']['user_subject'];
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_USER_EMAIL###");
				if ($template == '')	// if it is not in the template
					$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_USER_EMAIL###");
				$mailcontent = $this->cObj->substituteMarkerArray($template, $markerArrayP);
				$helperObj->sendEmail($mailcontent,$this->pi_getLL('email_text','email_text'),$quizData["email"],$quizData["name"],$this->conf['email.']['user_subject']);
			}
		}
		
		/** Redirect at the end of the quiz? **/
		if ($finalPage && $uidP) {		// redirect to a URL with that UID
			$this->redirectUrl($uidP, array($this->prefixId.'[name]'=>$quizData["name"],$this->prefixId.'[email]'=>$quizData["email"],$this->prefixId.'[homepage]'=>$quizData["homepage"]));
		}		
		
		return $this->pi_wrapInBaseClass($content . $helperObj->getDebug());
	}



	
	// show all answers
	function showAllAnswers($quizData, $thePID,$resPID, $tableQuestions, $tableAnswers, $tableRelation, $questionsTotal) {
		$questions = '';
		$statHash = array();
		$userHash = array();
		if ($this->conf['advancedStatistics']) {	// load and show advanced statistics
			$select = '';
			for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
				$select .= 	'sum(checked'.$answerNumber.'),';
			}			
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select.' question_id',
				$tableRelation,
				'pid='.$resPID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableRelation),
				'question_id',
				'',
				'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){
					$qno = $row['question_id'];
					for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
						$statHash[$qno]['c'.$answerNumber] = $row['sum(checked'.$answerNumber.')'];
					}
				}
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res5); 
			//print_r($statHash);
			
			if ($quizData["qtuid"]) {
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
					$tableRelation,
					'user_id='.intval($quizData["qtuid"]).' AND pid='.$resPID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableRelation),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){
						$qno = $row['question_id'];
						for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
							$userHash[$qno]['c'.$answerNumber] = $row['checked'.$answerNumber];
						}
						$userHash[$qno]['textinput'] = $row['textinput'];
						$userHash[$qno]['points'] = $row['points'];
					}
				}
				$GLOBALS['TYPO3_DB']->sql_free_result($res5);
			}
			//print_r($userHash);
			
			$template_okok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_ANSW###");
			$template_notok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_ANSW###");
		}
		$template_oknot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_NOTANSW###");
		$template_notnot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_NOTANSW###");
		
		// welches Template nehmen???
		if ($quizData["sendEmailNow"]) {
			$template_entry = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_EMAIL_ALLANSWERS###");
		} else if ($quizData["cmd"] == 'allanswers') {
			$template_entry = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_ALLANSWERS###");
		} else {
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NO_MORE###");
			$template_entry = $this->cObj->getSubpart($template, "###QUIZ_ANSWERS###");		
		}
		$template_answer = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR###");
		$template_expl = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_EXPLANATION###");
		$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");
		$template_image_begin = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_BEGIN###");
		$template_image_end = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_END###");

		$imgTSConfig = array();
		$myAArray = array();
		$markerArrayS = array();
		$markerArrayS["###PREFIX###"] = $this->prefixId;
		$markerArrayS["###EXPLANATION###"] = $this->pi_getLL('listFieldHeader_explanation','listFieldHeader_explanation');
		if ( !$this->conf['dontShowPoints'] ) {
			$markerArrayS["###P1###"] = $this->pi_getLL('p1','p1');
			$markerArrayS["###P2###"] = $this->pi_getLL('p2','p2');
			$markerArrayS["###NO_POINTS###"] = '0';
		} else {
			$markerArrayS["###P1###"] = '';
			$markerArrayS["###P2###"] = '';
			$markerArrayS["###NO_POINTS###"] = '';
		}
		$markerArrayS["###VAR_QUESTIONS###"] = $questionsTotal;
		
		$whereUIDs = '';
		if ($quizData["qtuid"]) {			// nur beantwortete Fragen anzeigen...
			$res4 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('qids,cids,fids',
					$tableAnswers,
					'uid='.intval($quizData["qtuid"]),
					'',
					'',
					'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res4);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res4)){
					$whereUIDs = ' AND uid IN (';
					if ($this->conf['showAllCorrectAnswers']==2)
						$whereUIDs .= $row['cids'];
					else if ($this->conf['showAllCorrectAnswers']==3)
						$whereUIDs .= $row['fids'];
					else $whereUIDs .= $row['qids'];
					$whereUIDs .= ')';
				}
			}
		}
		
		$sortBy = 'sorting';
		if ( $this->conf['sortBy'] ) {
			switch ($this->conf['sortBy']) {
				case "uid": $sortBy = "uid"; break;
				case "title": $sortBy = "title"; break;
				default: $sortBy = "sorting";
			}
		}
		
		// Get all questions and answers from the database
		$questionsArray = array();
		$questionNumber = 0;
		$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
				$tableQuestions,
				'pid='.$thePID.$whereUIDs.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
				'',
				$sortBy,
				'');
		$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
		if ($rows>0) {
			if (!$questionsTotal)
				$markerArrayS["###VAR_QUESTIONS###"] = $rows;
			while($rowA = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){
				$questionUID = $rowA['uid'];
				
				if ($this->conf['advancedStatistics'] && $quizData["qtuid"] && !is_array($userHash[$questionUID]))
					continue;				// vorher nicht angezeigte Fragen auch jetzt nicht anzeigen! 
				
				$questionNumber++;
				$answerPointsBool = false;
				$markerArrayS["###VAR_QUESTION###"] = $questionNumber;
				$markerArrayS["###VAR_QUESTION_TITLE###"] = $rowA['title'];
				$markerArrayS["###VAR_QUESTION_NAME###"] = $this->formatStr($this->local_cObj->stdWrap($rowA['name'],$this->conf["general_stdWrap."])); // $this->pi_RTEcssText($rowA['name']);
				$markerArrayS["###REF_QR_ANSWER_CORR###"] = '';
				$markerArrayS["###REF_QR_ANSWER_ALL###"] = '';
				$markerArrayS["###REF_QR_EXPLANATION###"] = '';
				if ($questionNumber < $rows) {
					$markerArrayS["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArrayS);
				} else {
					$markerArrayS["###REF_DELIMITER###"] = '';
				}
				if ( $rowA['explanation']!='' ) {	// Explanation
					$markerArrayS["###VAR_EXPLANATION###"] = $this->formatStr($this->local_cObj->stdWrap($rowA['explanation'],$this->conf["general_stdWrap."]));
					$markerArrayS["###REF_QR_EXPLANATION###"] = $this->cObj->substituteMarkerArray($template_expl, $markerArrayS);
				}
				if ($rowA['image']) {
					$imgTSConfig['file'] = 'uploads/tx_myquizpoll/'.$rowA['image']; //The image field name
					$imgTSConfig['altText'] = $rowA["alt_text"];
					$imgTSConfig['titleText'] = $rowA["alt_text"];
					if (is_array($this->conf['images.'])) {
						$imgTSConfig['file.']['maxW'] = $this->conf['images.']['maxW'];
						$imgTSConfig['file.']['maxH'] = $this->conf['images.']['maxH'];
					}
					$markerArrayS["###VAR_QUESTION_IMAGE###"] = $this->cObj->IMAGE($imgTSConfig);	// statt $this->conf["image."]
					$markerArrayS["###REF_QUESTION_IMAGE_BEGIN###"] = $this->cObj->substituteMarkerArray($template_image_begin, $markerArrayS);
					$markerArrayS["###REF_QUESTION_IMAGE_END###"] = $template_image_end;
				} else {
					$markerArrayS["###REF_QUESTION_IMAGE_BEGIN###"] = '';
					$markerArrayS["###REF_QUESTION_IMAGE_END###"] = '';
				}
			/*	if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] && $this->conf['noNegativePoints']<3 ) { // 20.01.10: wenn alles richtig sein muss, antwort-punkte ignorieren
					for ($currentValue=1; $currentValue <= $this->answerChoiceMax; $currentValue++) {
						if (intval($rowA['points'.$currentValue])>0 ) {
							$answerPointsBool = true;
							break;
						}
					}
				}*/
				
				if (is_array($this->conf['myVars.']['questions.'])) {
					foreach($this->conf['myVars.']['questions.'] as $key => $value) {
						$myQArray = split(',', $value);
						$myKey = ($questionNumber-1)%count($myQArray);
						$markerArrayS["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
					}
				}
					
				for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
					if ($rowA['answer'.$answerNumber] || $rowA['answer'.$answerNumber] === '0' || $rowA['qtype']==5) {	// was a answer set in the backend?
						
						if (is_array($this->conf['myVars.']['answers.'])) {						// custom variables
							foreach($this->conf['myVars.']['answers.'] as $key => $value) {
								$myAArray = split(',', $value);
								$myKey = ($answerNumber-1)%count($myAArray);
								$markerArrayS["###MY_".strtoupper($key)."###"] = $myAArray[$myKey];
							}
						}
							
					//	if ($this->conf['advancedStatistics'] and $quizData["qtuid"]) {
							$tempAnswer = '';
							$markerArrayS['###VAR_QUESTION_ANSWER###'] = $rowA['answer'.$answerNumber];
							if ( !$this->conf['dontShowPoints'] ) {  // && !$this->conf['isPoll'] ) {
								$markerArrayS["###VAR_ANSWER_POINTS###"] = 0;
								if ($this->conf['noNegativePoints']<3)	// das ganze Verhalten am 21.01.10 geaendert...
									$markerArrayS['###VAR_ANSWER_POINTS###'] = intval($rowA['points'.$answerNumber]);
								if ($markerArrayS['###VAR_ANSWER_POINTS###'] > 0) {
									$rowA['correct'.$answerNumber] = true;		// ACHTUNG: falls Punkte zu einer Antwort gesetzt sind, dann wird die Antwort als RICHTIG bewertet!
								} else {
									$markerArrayS['###VAR_ANSWER_POINTS###'] = intval($rowA['points']);
								}
							/*	if ($answerPointsBool) {		// Bug fixed at 10.11.2009
									$markerArrayS["###VAR_ANSWER_POINTS###"] = intval($rowA['points'.$answerNumber]);
									if ($markerArrayS["###VAR_ANSWER_POINTS###"] > 0)
										$rowA['correct'.$answerNumber] = true;		// ACHTUNG: falls Punkte zu einer Antwort gesetzt sind, dann wird die Antwort als RICHTIG bewertet!
								} else {
									$markerArrayS["###VAR_ANSWER_POINTS###"] = $rowA['points']; //intval($rowA['points']);
								}*/
							} else {
								$markerArrayS["###VAR_ANSWER_POINTS###"] = '';
							}
							if ($this->conf['advancedStatistics']) {
								if ($statHash[$questionUID]['c1']+$statHash[$questionUID]['c2']+$statHash[$questionUID]['c3']+$statHash[$questionUID]['c4']+$statHash[$questionUID]['c5'] > 0)
									$markerArrayS['###VAR_PERCENT###'] = number_format(100 * $statHash[$questionUID]['c'.$answerNumber] / ($statHash[$questionUID]['c1']+$statHash[$questionUID]['c2']+$statHash[$questionUID]['c3']+$statHash[$questionUID]['c4']+$statHash[$questionUID]['c5']), 2, ',', ' ');
								else
									$markerArrayS['###VAR_PERCENT###'] = '0';
								$markerArrayS['###VAR_COUNTS###'] = $statHash[$questionUID]['c'.$answerNumber];
							}
							
							if ($this->conf['advancedStatistics'] && $quizData["qtuid"] && $userHash[$questionUID]['c'.$answerNumber] && ( ($rowA['qtype']==3 && strtolower($rowA['answer'.$answerNumber])==strtolower($userHash[$questionUID]['textinput'])) ||
											($rowA['qtype']!=3 && $rowA['correct'.$answerNumber]) || ($rowA['qtype']==5) )) {
								if ($rowA['qtype']==5) $markerArrayS["###VAR_QUESTION_ANSWER###"] = $userHash[$questionUID]['textinput'];
								$tempAnswer = $this->cObj->substituteMarkerArray($template_okok, $markerArrayS);
							} else if ($this->conf['advancedStatistics'] and $quizData["qtuid"] && $userHash[$questionUID]['c'.$answerNumber]) {											
								$tempAnswer = $this->cObj->substituteMarkerArray($template_notok, $markerArrayS);
							} else if ($rowA['correct'.$answerNumber]) {
								$tempAnswer = $this->cObj->substituteMarkerArray($template_oknot, $markerArrayS);
								if ($this->conf['advancedStatistics'] and $quizData["qtuid"] && $rowA['qtype']==3 && ($userHash[$questionUID]['textinput'] || $userHash[$questionUID]['textinput']==='0')) {		// falsche antwort und richtige antwort ausgeben; hier gibt es 2 antworten !!!
									$markerArrayS["###VAR_QUESTION_ANSWER###"] = $userHash[$questionUID]['textinput'];		// falschen werte berechnen...
									if ($statHash[$questionUID]['c1']+$statHash[$questionUID]['c2']+$statHash[$questionUID]['c3']+$statHash[$questionUID]['c4']+$statHash[$questionUID]['c5'] > 0)
										$markerArrayS['###VAR_PERCENT###'] = number_format(100 * $statHash[$questionUID]['c2'] / ($statHash[$questionUID]['c1']+$statHash[$questionUID]['c2']), 2, ',', ' ');
									else
										$markerArrayS['###VAR_PERCENT###'] = '0';
									$markerArrayS['###VAR_COUNTS###'] = $statHash[$questionUID]['c2'];
									$tempAnswer .= $this->cObj->substituteMarkerArray($template_notok, $markerArrayS);
								}
							} else {
								$tempAnswer = $this->cObj->substituteMarkerArray($template_notnot, $markerArrayS);
							}
							$markerArrayS["###REF_QR_ANSWER_ALL###"] .= $tempAnswer;		// all answers in correct order
					
					//	} else 
						if ($rowA['correct'.$answerNumber] || $rowA['qtype']==3 || $rowA['qtype']==5) { // all correct answers
					//		$markerArrayS["###VAR_QUESTION_ANSWER###"] = $rowA['answer'.$answerNumber];
							$markerArrayS["###REF_QR_ANSWER_CORR###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArrayS);
						}
					}
					if ($rowA['qtype']==5) break 1;
				}
				
				if ($this->conf['advancedStatistics'] and $quizData["qtuid"]) {
					$markerArrayS['###RESULT_QUESTION_POINTS###'] = $this->pi_getLL('result_question_points','result_question_points');
					$markerArrayS['###VAR_POINTS###'] = $userHash[$questionUID]['points'];
				}
				
				$questions .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
			}
		}
		$GLOBALS['TYPO3_DB']->sql_free_result($res5);
		return $questions;
	}
	
	
	// show highscore list
	function showHighscoreList($quizData, $resPID, $tableAnswers) {
	
			$nr=0;
			$limit='';
			$date_format='m-d-Y';
			if ( $this->conf['dateFormat'] ) { $date_format=$this->conf['dateFormat']; } // date format
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE###");
			$template_entry = $this->cObj->getSubpart($template, "###TEMPLATE_HIGHSCORE_ENTRY###");
			$template_caption = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_CAPTION###");
			$template_quiz_taker = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_QUIZ_TAKER###");
			
			$markerArray=array();
			$markerArrayH=array();
			$markerArrayS=array();
			$markerArray["###PREFIX###"] = $this->prefixId;
			$markerArray["###REF_HIGHSCORE_CAPTION###"] = '';
			$markerArray["###REF_HIGHSCORE_ENTRY###"] = '';
			
			if ( $this->conf['highscoreEntries']>0 ) {
				$markerArray["###HIGHSCORE_CAPTION###"] = $this->pi_getLL('highscore_caption','highscore_caption');
				$markerArray["###VAR_HIGHSCORE_LIMIT###"] = $this->conf['highscoreEntries'];
				$markerArray["###REF_HIGHSCORE_CAPTION###"] = $this->cObj->substituteMarkerArray($template_caption, $markerArray);
				$limit = $this->conf['highscoreEntries'];
			}
			
			$markerArray["###NUMBER###"] = $this->pi_getLL('number','number');
			$markerArray["###POINTS###"] = $this->pi_getLL('points','points');
			$markerArray["###PERCENT###"] = $this->pi_getLL('percent','percent');
			$markerArray["###TIME###"] = $this->pi_getLL('time','time');
			$markerArray["###NAME###"] = $this->pi_getLL('name','name');
			$markerArray["###DATE###"] = $this->pi_getLL('date','date');
			
			if ( $this->conf['sortHighscoreBy']=='percent' ) {
				$orderBy='percent DESC';
			} else if ( $this->conf['sortHighscoreBy']=='o_percent' ) {
				$orderBy='o_percent DESC';
			} else if ( $this->conf['sortHighscoreBy']=='time' ) {
				$orderBy='(lasttime-firsttime) ASC';
			} else {
				$orderBy='p_or_a DESC';
			}
			
			$res4 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,p_or_a,p_max,percent,o_max,o_percent,lasttime,firsttime,name,email,homepage,crdate',
					$tableAnswers,
					'pid='.$resPID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'',
					$orderBy,
					$limit);
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res4);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res4)){
					$aDate = date($date_format, $row['crdate']);
					$aTime = mktime(0, 0, 0, 1, 1, 2009);
					$aTime += intval($row['lasttime'])-intval($row['firsttime']); // - 60*60;	// - 1 Stunde, warum auch immer das noetig ist...
					$aTime = date('G:i:s', $aTime);
					
					if ($row['uid'] == $quizData["qtuid"]) {		// aktueller eintrag
						$markerArrayS["###EVEN_ODD###"] = $markerArrayS["###MY_EVEN_ODD###"] = '-act';
					} else {
						if (is_array($this->conf['myVars.']['list.'])) {
							foreach($this->conf['myVars.']['list.'] as $key => $value) {
								$myQArray = split(',', $value);
								$myKey = ($nr)%count($myQArray);
								$markerArrayS["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
							}
						} else {		// aus kompatibilitaetsgruenden
							if (($nr % 2) == 0) {
								$markerArrayS["###EVEN_ODD###"] = ' tr-even';
							} else {
								$markerArrayS["###EVEN_ODD###"] = ' tr-odd';
							}
							$markerArrayS["###MY_EVEN_ODD###"] = $markerArrayS["###EVEN_ODD###"];	// hinzugefuegt am 2.9.2009
						}
					}
					
					$markerArrayH["###VAR_NAME###"] = $row['name'];
					$markerArrayH["###VAR_EMAIL###"] = $row['email'];
					$markerArrayH["###VAR_HOMEPAGE###"] = $row['homepage'];
					if ($row['homepage'] != "" && $row['homepage'] != $this->pi_getLL('no_homepage','no_homepage')) {
						$url_http=$row['homepage'];
						if (substr($url_http, 0,4) != 'http')
							$url_http='http://'.$url_http;
						$markerArrayH["###VAR_TO_HOMEPAGE###"] = "<a href=\"".$url_http."\" target=\"hp\">-&gt; ".$this->pi_getLL('homepage','homepage')."</a><br/>";
					} else {
						$markerArrayH["###VAR_TO_HOMEPAGE###"] = '';
					}
					$markerArrayH["###VAR_NAME_AND_EMAIL###"] = $row['name']."<br/>\n";
					if ($row['email'] != "" && $row['email'] != $this->pi_getLL('no_email','no_email')) {
						$email_crypt = $GLOBALS['TSFE']->encryptEmail('mailto:'.$row['email']); 
						if ($email_crypt == 'mailto:'.$row['email']) {		// Bug fixed: not always linkTo_UnCryptMailto
							$nameandemail = $email_crypt;
						} else {
							$nameandemail = "javascript:linkTo_UnCryptMailto('".$email_crypt."')";
						}
						$markerArrayH["###VAR_NAME_AND_EMAIL###"] = '<a href="'.$nameandemail.'">'.$row['name']."</a><br/>\n";
					}
					$markerArrayS["###REF_HIGHSCORE_QUIZ_TAKER###"] = $this->cObj->substituteMarkerArray($template_quiz_taker, $markerArrayH);
					
					$markerArrayS["###VAR_COUNT###"] = $nr+1;
					$markerArrayS["###VAR_POINTS###"] = $row['p_or_a'];
					$markerArrayS["###VAR_MAX###"] = $row['p_max'];
					$markerArrayS["###VAR_O_MAX###"] = $row['o_max'];
					$markerArrayS["###VAR_PERCENT###"] = $row['percent'];
					$markerArrayS["###VAR_O_PERCENT###"] = $row['o_percent'];
					$markerArrayS["###VAR_TIME###"] = $aTime;
					$markerArrayS["###VAR_DATE###"] = $aDate;
					$markerArray["###REF_HIGHSCORE_ENTRY###"] .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
					
					$nr++;
				}
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res4); 
			$subpart = $template;
			$template = $this->cObj->substituteSubpart($subpart, '###TEMPLATE_HIGHSCORE_ENTRY###', $markerArray["###REF_HIGHSCORE_ENTRY###"], 0);
			$out = $this->cObj->substituteMarkerArray($template, $markerArray);
			return $out;
	}
	
	
	// show poll result
	function showPollResult($answered, $quizData, $thePID,$resPID, $tableQuestions, $tableAnswers) {
	
			// poll answers
			$votes=0;
			$hits=0;
			$percent=0;

			if (!$answered) {	// link clicked?
				$answered = $quizData["qid"];
			}
			if ($answered) {
				$answeredP = ' AND uid='.$answered;
				$answeredQ = ' AND qids='.$answered;
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLLRESULT###");
			$template_entry = $this->cObj->getSubpart($template, "###TEMPLATE_POLLRESULT_ENTRY###");
			
			$markerArray=array();
			$markerArrayS=array();
			$markerArray["###PREFIX###"] = $this->prefixId;
			$markerArray["###REF_POLLRESULT_ENTRY###"] = '';
			$markerArray["###ANSWER###"] = $this->pi_getLL('answer','answer');
			$markerArray["###VOTES###"] = $this->pi_getLL('votes','votes');
			
			// poll question
			$query = 'SELECT * FROM '.$tableQuestions.' WHERE pid='.$thePID.$answeredP.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions);
			$queryResult = mysql( TYPO3_db, $query );
//			echo mysql_error();
			$row = mysql_fetch_assoc($queryResult);
			
			$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
			$markerArray["###VAR_QUESTION_NAME###"] = $this->formatStr($this->local_cObj->stdWrap($row['name'],$this->conf["general_stdWrap."])); // $this->pi_RTEcssText($row['name']);
			
			// votes
			$res2 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('count(p_or_a), p_or_a',
					$tableAnswers,
					'pid='.$resPID.$answeredQ.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'p_or_a',
					'p_or_a',
					'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res2);
			if ($rows>0) {
				while($row2 = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res2)){
					$aAnswer=$row2['p_or_a'];
					if ($aAnswer) {		// since 0.2.1
						$row['votes'.$aAnswer]=$row2['count(p_or_a)'];	// Votes for a answer
						$votes+=$row2['count(p_or_a)'];
					}
				}
			}
			
			// show the answers and votes
			for ($nr=1; $nr<=$this->answerChoiceMax; $nr++) {
			  if ($row['answer'.$nr] || $row['answer'.$nr]==='0') {
				if (is_array($this->conf['myVars.']['list.'])) {
					foreach($this->conf['myVars.']['list.'] as $key => $value) {
						$myQArray = split(',', $value);
						$myKey = ($nr-1)%count($myQArray);
						$markerArrayS["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
					}
				} else {
					$markerArrayS["###EVEN_ODD###"] = (($nr % 2) == 0) ? ' tr-even' : ' tr-odd';
				}
						
				$markerArrayS["###VAR_ANSWER###"] = $row['answer'.$nr];
				if ($row['votes'.$nr]) {
					$hits=$row['votes'.$nr];
					$percent=round(100*$row['votes'.$nr]/$votes, 2);
				} else {
					$hits=0;
					$percent=0;
				}
				$markerArrayS["###VAR_HITS###"] = $hits;
				$markerArrayS["###VAR_PERCENT###"] = $percent;
				$markerArray["###REF_POLLRESULT_ENTRY###"] .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
				$markerArray["###VAR_ANSWER$nr###"] = $markerArrayS["###VAR_ANSWER###"];
				$markerArray["###VAR_HITS$nr###"] = $markerArrayS["###VAR_HITS###"];
				$markerArray["###VAR_PERCENT$nr###"] = $markerArrayS["###VAR_PERCENT###"];
			  }
			}
			$markerArray["###VAR_VOTES###"] = $votes;
			$this->subpart = $template;
			$template = $this->cObj->substituteSubpart($this->subpart, '###TEMPLATE_POLLRESULT_ENTRY###', $markerArray["###REF_POLLRESULT_ENTRY###"], 0);
			$out = $this->cObj->substituteMarkerArray($template, $markerArray);
			mysql_free_result($queryResult);
			return $out;
	}
	
	
	/**
	 * Format string with nl2br and htmlspecialchars()
	 */
	function formatStr($str)	{
		if (is_array($this->conf["general_stdWrap."]))	{
			$str = $this->local_cObj->stdWrap($str, $this->conf["general_stdWrap."]);
		}
		return $str;
	}
	
	
	/**
    * read the template file, fill in global wraps and markers and write the result
    * to '$this->templateCode'
    *
    * @return    void
    */
	function initTemplate() {
       // read template-file
       $templateFile = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'templateFile');
       $origTemplateFile = 'EXT:myquizpoll/pi1/tx_myquizpoll_pi1.tmpl';	
	   if ($templateFile) {
           if (false === strpos($templateFile, '/')) {
               $templateFile = 'uploads/tx_myquizpoll/' . $templateFile;
           }
       } else if ($this->conf['templateFile']) {
           $templateFile = $this->conf['templateFile'];
       } else {
	   	   $templateFile = $origTemplateFile;		  
       }
	   $this->templateCode = $this->cObj->fileResource($templateFile);
	   $this->origTemplateCode = $this->cObj->fileResource($origTemplateFile);
	} 

   
	/**
    * copy flexform-values to '$this->conf'
    *
    * @return    void
    */
	function copyFlex() {
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'what_to_display');
		if ($value and $value!='TS') {
			if ($value=='NORMAL')
				$this->conf['CMD'] = '';
			else
				$this->conf['CMD'] = $value;
		}
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'isPoll');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['isPoll'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'nextPID');
		if ($value)
			$this->conf['nextPID'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'finalPID');
		if ($value)
			$this->conf['finalPID'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'startPID');
		if ($value)
			$this->conf['startPID'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'listPID');
		if ($value)
			$this->conf['listPID'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'pageQuestions');
		if ($value || $value==='0' || $value===0)
			$this->conf['pageQuestions'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'answerChoiceMax');
		if ($value || $value==='0' || $value===0)
			$this->conf['answerChoiceMax'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'quizName');
		if ($value)
			$this->conf['quizName'] = $value;
			
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'sortBy', 'sNEXT');
		if ($value and $value!='TS')
			$this->conf['sortBy'] = $value;
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAnswersSeparate', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['showAnswersSeparate'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'dontShowCorrectAnswers', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['dontShowCorrectAnswers'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAllCorrectAnswers', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['showAllCorrectAnswers'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'allowSkipping', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['allowSkipping'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'dontShowPoints', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['dontShowPoints'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'noNegativePoints', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['noNegativePoints'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'userSession', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userSession'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'enforceSelection', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['enforceSelection'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'doubleEntryCheck', 'sNEXT');
		if ($value || $value==='0' || $value===0)
			$this->conf['doubleEntryCheck'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'doubleCheckMode', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['doubleCheckMode'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'useCookiesInDays', 'sNEXT');
		if ($value || $value==='0' || $value===0)
			$this->conf['useCookiesInDays'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'cookieMode', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['cookieMode'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'loggedInMode', 'sNEXT');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['loggedInMode'] = intval($value);
		
		//if ($this->conf['dontShowUserResult']) // und dann???
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'askAtStart', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['askAtStart'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'askAtQuestion', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['askAtQuestion'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'askAtFinal', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['askAtFinal'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAtAnswer', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['showAtAnswer'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showAtFinal', 'sUSERDATA');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['userData.']['showAtFinal'] = intval($value);
		if ($this->conf['dontShowUserData']) 	// aus Kompatibilitaetsgruenden
			$this->conf['userData.']['askAtQuestion'] = 0;

		$value1 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till1p', 'sEVALUATION');
		$value2 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till1c', 'sEVALUATION');
		if ($value2) {
			$this->conf['showEvaluation'] = intval($value1).':'.intval($value2);
			$value1 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till2p', 'sEVALUATION');
			$value2 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till2c', 'sEVALUATION');
			if ($value2) {
				$this->conf['showEvaluation'] .= ','.intval($value1).':'.intval($value2);
				$value1 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till3p', 'sEVALUATION');
				$value2 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till3c', 'sEVALUATION');
				if ($value2) {
					$this->conf['showEvaluation'] .= ','.intval($value1).':'.intval($value2);
					$value1 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till4p', 'sEVALUATION');
					$value2 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till4c', 'sEVALUATION');
					if ($value2) {
						$this->conf['showEvaluation'] .= ','.intval($value1).':'.intval($value2);
						$value1 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till5p', 'sEVALUATION');
						$value2 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till5c', 'sEVALUATION');
						if ($value2) {
							$this->conf['showEvaluation'] .= ','.intval($value1).':'.intval($value2);							
							$value1 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till6p', 'sEVALUATION');
							$value2 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'till6c', 'sEVALUATION');
							if ($value2) {
								$this->conf['showEvaluation'] .= ','.intval($value1).':'.intval($value2);
							}
						}
					}
				}
			}
		}
			
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'send_admin', 'sEMAIL');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['email.']['send_admin'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'send_user', 'sEMAIL');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['email.']['send_user'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'admin_subject', 'sEMAIL');
		if ($value)
			$this->conf['email.']['admin_subject'] = $value;
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'user_subject', 'sEMAIL');
		if ($value)
			$this->conf['email.']['user_subject'] = $value;
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'from_name', 'sEMAIL');
		if ($value)
			$this->conf['email.']['from_name'] = $value;
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'from_mail', 'sEMAIL');
		if ($value)
			$this->conf['email.']['from_mail'] = $value;
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'admin_name', 'sEMAIL');
		if ($value)
			$this->conf['email.']['admin_name'] = $value;
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'admin_mail', 'sEMAIL');
		if ($value)
			$this->conf['email.']['admin_mail'] = $value;
			
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'useJokers', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['useJokers'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'jokersUnlimited', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['jokers.']['unlimited'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'jokersHalvePoints', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['jokers.']['halvePoints'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'advancedStatistics', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['advancedStatistics'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'enableCaptcha', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['enableCaptcha'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'loggedInCheck', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['loggedInCheck'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'debug', 'sFEATURES');
		if ($value!='TS' && ($value || $value==='0' || $value===0))
			$this->conf['debug'] = intval($value);
		$value = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'startCategory', 'sFEATURES');
		if ($value)
			$this->conf['startCategory'] = intval($value);
	}

    /**
     * does a redirect to a URL specified in the parameter and exits the request
     * @param    mixed    the URL to redirect to, if this is a numeric, it's supposed to be a
     *                     page ID, we should substitute this process at some point with the typoLink function
     *           array    Parameters for the link
     * @return   void
     */
    function redirectUrl($url, $addParams) {
        if (is_numeric($url)) {
            // these parameters have to be added to the redirect url: $addParams = array();
            if (t3lib_div::_GP('L')) {	// ob das noetig ist?
                $addParams['L'] = t3lib_div::_GP('L');
            }
            $url = $this->pi_getPageLink($url, '', $addParams);
        }
        if ($this->conf['correctRedirectUrl']) {	// ob das Sinn macht?
            $url = str_replace('&amp;', '&', $url);
        }
        header('Location: ' . t3lib_div::locationHeaderUrl($url));
        exit();
    }
	
    /**
     * Returns an XML document
     * @param    quid       question UID
     *           ruid       relation UID
     *           jokerNo    Joker number
     *           jokerName  Joker name
     */
	function getAjaxData($quid,$ruid,$jokerNo,$jokerName) {
		$sOut = '';
		$jsc = '';
		$nCount = 0;
		if ($this->conf['answerChoiceMax'])					// antworten pro fragen
			$this->answerChoiceMax = intval($this->conf['answerChoiceMax']);
			
		// DB-Anfrage nach Typo3-Coding-Guidline
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
			'*', // SELECT ...
			'tx_myquizpoll_question', // FROM ...
			'uid='.intval($quid), // WHERE...
			'', // GROUP BY...
			'', // ORDER BY...
			'' // LIMIT ...
		);
		$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($result);
		if ($jokerNo==1) {
			for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {					
				if ($row['joker1_'.$answerNumber]) {
					$sOut .= '; '.$row['answer'.$answerNumber];
				} else if ($row['answer'.$answerNumber]) {
					$jsc .= ", 'quiz_antwort$answerNumber'";
				}
			}
			$sOut = substr($sOut,2);
		} else if ($jokerNo==2) {
			for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {						
				if ($row['answer'.$answerNumber]) {
					$sOut .= '; '.$row['answer'.$answerNumber].': '.$row['joker2_'.$answerNumber].'%';
				}
			}
			$sOut = substr($sOut,2);
		} else if ($jokerNo==3) {
			$sOut = $row['joker3'];
		}
		if (!$sOut) $sOut = $this->pi_getLL('no_joker_answer','no_joker_answer');;
		
		if ($ruid > 0) {				// which Joker used?
			$timestamp = time();
			$update = array('tstamp' => $timestamp,
							'joker'.$jokerNo => 1,
							'lasttime' => $timestamp);
			$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_myquizpoll_result', 'uid='.intval($ruid).' AND sys_language_uid='.$this->lang, $update);
			if(!$success){
				$content.="<p>MySQL Update-Error :-(</p>";
			}
		}
		
		/* instantiate the xajaxResponse object */
		$objResponse = new tx_xajax_response();
		$objResponse->addScript("document.getElementById('".$this->prefixId."-joker').style.display = \"block\"");
		$objResponse->addScript("document.getElementById('".$this->prefixId."-$jokerName').style.display = \"none\"");
		
//		if(!$ruid)	{			// 9.8.09: man soll immer feststellen koennen, ob ein Joker benutzt wurde
			$objResponse->addScript('document.forms["myquiz"].elements["'.$this->prefixId.'[joker'.$jokerNo.']"].value = 1');
//			$objResponse->addScript("document.getElementById('".$box."').value = 1");
//		}
		
		if ($jsc) {
			$jsc = substr($jsc,2);
			$objResponse->addScript('hideByJoker ('.$jsc.')');
		}
		
		/* We alter the contents of the 'joker' HTML element. The property 'innerHTML' is the html code inside this element. We replace it with the result in our $sOut variable */
		$objResponse->addAssign($this->prefixId."-joker_answer", "innerHTML", $sOut);  
		/* With the getXML() method on the xajaxResponse objectwe send everything back to the client */
		return $objResponse->getXML();
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_pi1.php']);
}

?>